SystemOrganization addCategory: #'OmniBrowser-Tests'!
SystemOrganization addCategory: #'OmniBrowser-Fakes'!
SystemOrganization addCategory: #'OmniBrowser-Kernel'!
SystemOrganization addCategory: #'OmniBrowser-Morphs'!
SystemOrganization addCategory: #'OmniBrowser-Nodes'!
SystemOrganization addCategory: #'OmniBrowser-Actors'!
SystemOrganization addCategory: #'OmniBrowser-Notifications'!
SystemOrganization addCategory: #'OmniBrowser-Utilities'!

RectangleMorph subclass: #OBPane
	instanceVariableNames: 'model list button'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Morphs'!

!OBPane methodsFor: 'initialization' stamp: 'cwp 2/12/2004 18:35'!
adjustList
	self hasButton
			ifFalse: [list bounds: self innerBounds]
			ifTrue: [list bounds: (self innerBounds withHeight: (self height - self buttonHeight))]! !

!OBPane methodsFor: 'initialization' stamp: 'cwp 2/12/2004 20:30'!
addButton: aButton
	self hasButton ifTrue: [self removeMorph: button].
	button _ aButton.
	self 
		addMorph: button;
		adjustList;
		adjustButton! !

!OBPane methodsFor: 'initialization' stamp: 'cwp 2/12/2004 19:17'!
setColumn: aColumn filter: aFilter
	self model: aColumn.
	list _ aColumn listMorph.
	self initGeometry.
	aFilter ifNotNil: [self addButton: aFilter buttonMorph].! !

!OBPane methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2004 20:29'!
removeButton
	self hasButton 
		ifTrue: [self removeMorph: button.
				button _ nil.
				self adjustList]! !

!OBPane class methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2004 18:12'!
forColumn: aColumn withFilter: aFilter
	^ self new setColumn: aColumn filter: aFilter! !

!OBPane class methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2004 18:11'!
forColumn: aColumn
	^ self forColumn: aColumn withFilter: nil! !

!OBPane methodsFor: 'initialization' stamp: 'cwp 2/12/2004 20:23'!
update: aSelector
	aSelector = #filter ifFalse: [^ self].
	(model wantsButton)
			ifTrue: [self addButton: model filter buttonMorph]
			ifFalse: [self removeButton]! !

!OBPane methodsFor: 'as yet unclassified' stamp: 'cwp 2/12/2004 18:47'!
buttonHeight
	^ 20! !

!OBPane methodsFor: 'initialization' stamp: 'cwp 2/12/2004 18:39'!
adjustButton
	| inner |
	self hasButton ifTrue: 	[inner _ self innerBounds.
							button bounds: (inner withTop: inner bottom - self buttonHeight)]! !

!OBPane methodsFor: 'initialization' stamp: 'cwp 2/12/2004 18:26'!
initGeometry
	self	
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		clipSubmorphs: true;
		color: Color transparent;
		cellInset: 0;
		borderWidth: 0;
		layoutPolicy: ProportionalLayout new.
		
	self addMorph: list.
	list bounds: self innerBounds.
		! !

!OBPane methodsFor: 'initialization' stamp: 'cwp 2/12/2004 18:32'!
bounds: aRectangle
	super bounds: aRectangle.
	self adjustList.
	self adjustButton.! !

!OBPane methodsFor: 'initialization' stamp: 'cwp 2/12/2004 18:44'!
model: anObject
	"Set my model and make me me a dependent of the given object."

	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model _ anObject.
! !

!OBPane methodsFor: 'initialization' stamp: 'cwp 2/12/2004 18:35'!
hasButton
	^ button notNil! !

!OBPane methodsFor: 'constructing' stamp: 'cwp 2/12/2004 18:14'!
listMorphForColumn: aColumn
	^ (PluggableListMorph
		on: aColumn
		list: #list
		selected: #selection
		changeSelected: #selection:
		menu: #menu:
		keystroke: #keystroke:from:)
			borderWidth: 0! !

RectangleMorph subclass: #OBRadioButtonBar
	instanceVariableNames: 'model buttons selection getListSelector getSelectionSelector setSelectionSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Morphs'!

!OBRadioButtonBar methodsFor: 'initialize-release' stamp: 'cwp 2/25/2004 00:36'!
on: aModel list: listSelector selected: selectionGetter changeSelected: selectionSetter 
	self model: aModel.
	selection _ 0.
	getListSelector _ listSelector.
	getSelectionSelector _ selectionGetter.
	setSelectionSelector _ selectionSetter.
	self initGeometry.
	self updateList.! !

!OBRadioButtonBar methodsFor: 'updating' stamp: 'cwp 2/24/2004 19:28'!
updateMorphs
	self removeAllMorphs.
	buttons do: [:button | self addMorphBack: button morph]! !

!OBRadioButtonBar methodsFor: 'updating' stamp: 'cwp 2/24/2004 19:38'!
withSelectedButtonDo: aBlock
	^ self withButtonAt: selection do: aBlock! !

!OBRadioButtonBar methodsFor: 'updating' stamp: 'cwp 2/24/2004 19:39'!
updateSelection
	| oldSelection |
	oldSelection _ selection.
	selection _ self getSelectionIndex.
	self withButtonAt: oldSelection do: [:button | button selectionChanged].
	self withSelectedButtonDo: [:button | button selectionChanged]! !

!OBRadioButtonBar methodsFor: 'accessing' stamp: 'cwp 2/24/2004 18:38'!
list 
	buttons ifNil: [self updateButtons].
	^ buttons collect: [:b | b label]! !

!OBRadioButtonBar methodsFor: 'updating' stamp: 'cwp 2/24/2004 19:38'!
withButtonAt: index do: aBlock
	^ (buttons at: index ifAbsent: [nil]) ifNotNilDo: aBlock! !

!OBRadioButtonBar methodsFor: 'updating' stamp: 'cwp 2/25/2004 00:35'!
update: aSymbol
	aSymbol = getListSelector ifTrue: [self updateList. ^ self].
	aSymbol = getSelectionSelector ifTrue: [self updateSelection]! !

!OBRadioButtonBar class methodsFor: 'as yet unclassified' stamp: 'cwp 2/22/2004 16:44'!
on: aModel list: listSelector selected: selectionSelector changeSelected: changedSelector 
	^ self new
			on: aModel
			list: listSelector
			selected: selectionSelector
			changeSelected: changedSelector! !

!OBRadioButtonBar methodsFor: 'updating' stamp: 'cwp 2/25/2004 00:35'!
updateList
	self 
		updateButtons; 
		updateMorphs. ! !

!OBRadioButtonBar methodsFor: 'initialize-release' stamp: 'cwp 2/24/2004 17:42'!
initGeometry
	self 
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		rubberBandCells: true;
		borderWidth: 0
! !

!OBRadioButtonBar methodsFor: 'initialize-release' stamp: 'cwp 2/22/2004 16:51'!
model: aModel
	model ifNotNil: [model removeDependent: self].
	model _ aModel.
	model addDependent: self.! !

!OBRadioButtonBar methodsFor: 'updating' stamp: 'cwp 2/24/2004 18:53'!
getSelectionIndex
	^ model perform: getSelectionSelector! !

!OBRadioButtonBar methodsFor: 'updating' stamp: 'cwp 2/24/2004 18:53'!
updateButtons
	| labels |
	labels _ model perform: getListSelector.
	buttons _ Array new: labels size.
	labels withIndexDo: [:label :index | 
						buttons at: index put: (OBButtonModel withLabel: label inBar: self)].
	selection _ self getSelectionIndex! !

!OBRadioButtonBar methodsFor: 'updating' stamp: 'cwp 2/24/2004 18:54'!
isSelected: aButton
	^ (buttons at: selection ifAbsent: [^ false]) == aButton! !

!OBRadioButtonBar methodsFor: 'updating' stamp: 'cwp 2/24/2004 18:47'!
push: aButton
	| index |
	index _ buttons indexOf: aButton.
	model perform: setSelectionSelector with: index.! !

RectangleMorph subclass: #OBPaneScroller
	instanceVariableNames: 'sizing count transform scrollBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Morphs'!

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 11:10'!
adjustPaneHeight
	"This gets called after the scrollbar has been shown or hidden, to move the bottom
	of the panes to the right place."
	
	transform bounds: self innerBounds.
	transform submorphsDo: [:m | m bounds: (m bounds withHeight: self paneHeight)]
		! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 10:53'!
fullLayout
	self layoutWidgets.
	self layoutPanes.
	self setScrollDeltas.
	self scrollToRight.! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 8/25/2003 21:04'!
leftoverScrollRange
	^ (self totalScrollRange - self innerBounds width roundTo: self scrollDeltaWidth) max: 0
! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 2/8/2004 10:42'!
isScrollable
	^ self leftoverScrollRange > 0! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 8/25/2003 19:27'!
totalScrollRange
	| submorphBounds |
	submorphBounds := transform localSubmorphBounds ifNil: [^ 0].
	^ submorphBounds width
! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 2/8/2004 11:10'!
hideScrollBar
	self removeMorph: scrollBar.
	self adjustPaneHeight.! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 2/11/2004 22:44'!
pushPane: aMorph
	aMorph 
		borderWidth: 0;
		hResizing: #rigid;
		vResizing: #rigid;
		layoutInset: 0.
	transform hasSubmorphs ifTrue: [transform addMorphBack: self separator].
	transform addMorphBack: aMorph.
	self doLayout! !

!OBPaneScroller methodsFor: 'initialization' stamp: 'cwp 2/8/2004 10:52'!
initializeTransform
	transform _ TransformMorph new.
	transform
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		disableTableLayout;
		bounds: super innerBounds.
	self addMorphBack: transform.
! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 12/8/2003 21:42'!
scrollToRight
	^ scrollBar setValue: 1.! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 00:53'!
separatorCount
	^ self paneCount - 1! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 2/8/2004 11:11'!
showScrollBar
	self scrollBarIsVisible ifTrue: [^ self].
	self resizeScrollBar.
	self addMorphFront: scrollBar.
	self adjustPaneHeight.
	! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 11:03'!
resizeScrollBar
	| inner outer |
	outer _ super innerBounds.
	inner _ outer withHeight: outer height - self scrollBarHeight - 1.
	scrollBar bounds: ((inner left @ inner bottom + 1)
						corner: outer bottomRight)! !

!OBPaneScroller methodsFor: 'initialization' stamp: 'cwp 2/8/2004 11:01'!
initializeScrollbar
	scrollBar _ OBScrollBar new model: self slotName: 'scrollBar'.
	scrollBar 
		borderWidth: 0;
		borderColor: #inset;
		height: self scrollBarHeight.
	self resizeScrollBar.
! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 2/8/2004 10:44'!
hideOrShowScrollBar
	self isScrollable ifTrue: [self showScrollBar] ifFalse: [self hideScrollBar]! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 00:59'!
computeMorphWidths
	| paneWidths widths |
	paneWidths _ self 
					padWidths: (self panes collect: [:pane | pane idealWidth])
					toFit: self totalPaneWidth.
	widths _ OrderedCollection new.
	paneWidths do: [:w | widths add: w] separatedBy: [widths add: self separatorWidth].
	^ widths asArray
! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/17/2004 18:40'!
paneWidth
	^ (self totalPaneWidth / self sizing) floor! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 8/25/2003 21:20'!
bounds: aRectangle
	super bounds: aRectangle.
	self doLayout.! !

!OBPaneScroller methodsFor: 'input events' stamp: 'cwp 8/25/2003 20:33'!
scrollBarValue: value
	transform hasSubmorphs ifFalse: [^ self].
	transform offset: (self leftoverScrollRange * value) rounded @ 0.! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 8/25/2003 21:14'!
setScrollDeltas
	| range interval value |
	transform hasSubmorphs ifFalse: [scrollBar interval: 1.0. ^ self].
	range _ self leftoverScrollRange.
	range = 0 ifTrue: [^ scrollBar interval: 1.0; setValue: 0].
	interval _ ((self innerBounds width) / self totalScrollRange) asFloat.
	value _ (transform offset x / range min: 1.0) asFloat.
	scrollBar interval: interval.
	scrollBar setValue: value.! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 11:06'!
doLayout
	self layoutWidgets.
	self layoutPanes.
	self hideOrShowScrollBar.
	self setScrollDeltas.
	self scrollToRight.! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 2/8/2004 01:21'!
panes
	| panes subs |
	subs _ transform submorphs.
	panes _ Array new: (subs size / 2) ceiling.
	1 to: subs size by: 2 do: [:i | panes at: (i / 2) ceiling put: (subs at: i)].
	^ panes! !

!OBPaneScroller methodsFor: 'defaults' stamp: 'cwp 8/24/2003 15:13'!
separatorWidth
	^ 4! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 2/11/2004 22:46'!
popPane
	2 timesRepeat: [transform removeMorph: transform lastSubmorph].
	self doLayout! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 8/25/2003 22:13'!
layoutWidgets
	| inner outer |
	outer _ super innerBounds.
	inner _ self innerBounds.
	transform bounds: inner.
	scrollBar bounds: ((inner left @ inner bottom + 1)
						corner: outer bottomRight)! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 8/23/2003 16:21'!
scrollDeltaWidth
	^ 1! !

!OBPaneScroller methodsFor: 'initialization' stamp: 'cwp 2/17/2004 18:40'!
initialize
	super initialize.
	self sizing: 3.
	self 
		color: Color red;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	self 
		initializeTransform;
		initializeScrollbar.
! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 12/6/2003 17:07'!
paneCount
	^ (transform submorphs size / 2) ceiling.! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 8/24/2003 15:15'!
separator
	^ BorderedSubpaneDividerMorph vertical 
		borderWidth: self separatorWidth / 2;
		color: Color lightGray;
		borderRaised.! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 12/6/2003 17:06'!
clearPanes
	transform removeAllMorphs! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/25/2004 20:23'!
padWidths: widths toFit: limit
	| padded |
	padded _ Array new: widths size.
	padded atAllPut: (limit / self sizing) floor.
	(1 to: limit - padded sum) do: [:i | padded at: i put: (padded at: i) + 1].
	^ padded
	
	! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/25/2004 20:23'!
totalPaneWidth
	^ self innerBounds width - ((self sizing - 1) * self separatorWidth)! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 8/24/2003 14:29'!
scrollBarHeight
	^ 12! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 12/6/2003 17:08'!
paneHeight
	^ transform bounds height! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 10:54'!
innerBounds
	| rect |
	rect _ super innerBounds.
	^ self scrollBarIsVisible
		ifTrue: [rect withHeight: rect height - self scrollBarHeight - 1]
		ifFalse: [rect]! !

!OBPaneScroller methodsFor: 'accessing' stamp: 'cwp 2/17/2004 18:39'!
sizing: anInteger
	sizing _ anInteger! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 01:22'!
layoutPanes
	| widths rect |
	widths _ self computeMorphWidths.
	rect _ 0@0 extent: (0 @ self paneHeight).
	transform submorphs 
					with: widths 
					do: [:m :w | 
						rect _ rect withWidth: w.
						m bounds: rect.
						rect _ rect translateBy: (w@0)]
						
! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 2/8/2004 10:56'!
scrollBarIsVisible
	^ submorphs includes: scrollBar! !

!OBPaneScroller methodsFor: 'accessing' stamp: 'cwp 2/17/2004 18:39'!
sizing
	^ sizing min: (self panes size)! !

!RectangleMorph methodsFor: '*omnibrowser' stamp: 'cwp 2/8/2004 00:17'!
idealWidth
	^ 100! !

Object subclass: #OBButtonModel
	instanceVariableNames: 'bar label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Morphs'!

!OBButtonModel methodsFor: 'callbacks' stamp: 'cwp 2/24/2004 18:42'!
isSelected
	^ bar isSelected: self! !

!OBButtonModel methodsFor: 'accessing' stamp: 'cwp 2/24/2004 18:41'!
label
	^ label! !

!OBButtonModel methodsFor: 'callbacks' stamp: 'cwp 2/24/2004 19:30'!
push
	bar push: self.! !

!OBButtonModel methodsFor: 'accessing' stamp: 'cwp 2/24/2004 18:29'!
label: aString
	label _ aString! !

!OBButtonModel methodsFor: 'accessing' stamp: 'cwp 2/24/2004 19:38'!
selectionChanged
	self changed: #isSelected! !

!OBButtonModel methodsFor: 'morphs' stamp: 'cwp 2/25/2004 20:30'!
morph
	| morph |
	morph _ PluggableButtonMorph
				on: self
				getState: #isSelected
				action: #push
				label: #label.
	morph 
		label: label;
		onColor: Color lightGray lighter offColor: Color lightGray twiceLighter;
		borderWidth: 2;
		borderRaised;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	^ morph! !

!OBButtonModel class methodsFor: 'as yet unclassified' stamp: 'cwp 2/24/2004 18:35'!
withLabel: aString inBar: aRadioButtonBar
	^ self new label: aString; bar: aRadioButtonBar! !

!OBButtonModel methodsFor: 'accessing' stamp: 'cwp 2/24/2004 18:29'!
bar: aRadioButtonBar
	bar _ aRadioButtonBar! !

Object subclass: #OBFakeClassA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Fakes'!

OBFakeClassA class
	instanceVariableNames: 'foo'!

!OBFakeClassA commentStamp: 'cwp 2/25/2004 01:09' prior: 0!
Comment for FakeClassA.!

!OBFakeClassA methodsFor: 'numbers' stamp: 'cwp 12/11/2003 20:57'!
three
	^ 3! !

!OBFakeClassA methodsFor: 'numbers' stamp: 'cwp 2/25/2004 22:44'!
one
	^ 1! !

!OBFakeClassA class methodsFor: 'capitals' stamp: 'cwp 2/9/2004 19:57'!
b
	^ $B! !

!OBFakeClassA methodsFor: 'letters' stamp: 'cwp 12/10/2003 23:06'!
b
	^ $b! !

!OBFakeClassA methodsFor: 'numbers' stamp: 'cwp 12/10/2003 23:05'!
two
	^ 2! !

!OBFakeClassA methodsFor: 'letters' stamp: 'cwp 2/9/2004 20:05'!
a
	^ $a! !

!OBFakeClassA methodsFor: 'numbers' stamp: 'cwp 2/8/2004 13:27'!
five
	^ self two + self three! !

!OBFakeClassA class methodsFor: 'capitals' stamp: 'cwp 2/25/2004 22:44'!
a
	^ $A! !

Object subclass: #OBBrowser
	instanceVariableNames: 'columns scroller size minPanes'
	classVariableNames: 'MetaGraphs'
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBBrowser methodsFor: 'notification' stamp: 'cwp 1/30/2004 00:40'!
nodeCreated: aNode
	self jumpTo: aNode! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 2/11/2004 23:20'!
emptyColumn
	^ OBColumn inBrowser: self! !

!OBBrowser class methodsFor: 'instance creation' stamp: 'cwp 12/17/2003 16:38'!
metaNode: aMetaNode node: aNode
	^ self new setMetaNode: aMetaNode node: aNode! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 2/17/2004 18:42'!
minPanes
	^ minPanes! !

!OBBrowser methodsFor: 'accessing' stamp: 'cwp 2/11/2004 22:48'!
popColumn
	columns removeLast.
	scroller popPane.
! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 12/18/2003 22:24'!
browseMetaGraphs
	(OBBrowser
		metaNode: OBMetaGraphBuilder default metaGraphBrowser
		node: (OBDictionaryNode on: MetaGraphs)) open! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 2/17/2004 18:46'!
scroller
	^ scroller ifNil: [scroller _ OBPaneScroller new.
					scroller 
						name: 'scroller';
						vResizing: #spaceFill;
						hResizing: #spaceFill;
						sizing: self minPanes;
						pushPane: columns first morph.
					scroller]
	! !

!OBBrowser methodsFor: 'callbacks' stamp: 'cwp 1/26/2004 21:45'!
text
	| node |
	node _ self currentNode.
	^ node 
		ifNil: ['']
		ifNotNil: [node text]! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 12/18/2003 18:13'!
removeMetaGraphAt: aSymbol
	MetaGraphs removeKey: aSymbol! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 12/18/2003 19:50'!
metaGraphs
	^ MetaGraphs! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 2/17/2004 18:24'!
metaGraphMissing: aSymbol
	^ self error: 'There is no metagraph named ', aSymbol.! !

!OBBrowser class methodsFor: 'instance creation' stamp: 'cwp 2/17/2004 18:45'!
browse: aSymbol fromRoot: rootNode select: selectedNode
	^ (self metaNode: (self metaGraphAt: aSymbol) node: rootNode)
		minPanes: 3;
		jumpTo: selectedNode;
		open! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 2/11/2004 23:39'!
deselected: aColumn
	self trimColumnsTo: (columns indexOf: aColumn)
! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 11/29/2003 17:37'!
window
	| window |
	window _ SystemWindow labelled: self label.
	window model: self.
	window 
		addMorph: self scroller
		fullFrame: (LayoutFrame fractions: (0@0 extent: 1@0.4)).
	window
		addMorph: self textPane
		fullFrame: (LayoutFrame fractions: (0@0.4 corner: 1@1)).
	^ window! !

!OBBrowser methodsFor: 'accessing' stamp: 'cwp 2/7/2004 16:52'!
currentOrRootNode
	^ (columns reversed 
				detect: [:ea | ea selection > 0] 
				ifNone: [^ columns first parent]) selectedNode
! !

!OBBrowser methodsFor: 'navigating' stamp: 'cwp 2/11/2004 23:12'!
jumpTo: aNode
	| column ancestor |
	column _ columns first.
	[ancestor _ column selectAncestorOf: aNode.
	ancestor = aNode or: [ancestor isNil]]
		whileFalse: [column _ columns after: column].					
! !

!OBBrowser methodsFor: 'accessing' stamp: 'cwp 2/11/2004 21:23'!
columnAfter: aColumn
	^ [columns after: aColumn]
		on: Error
		do: [^ nil]! !

!OBBrowser methodsFor: 'initializing' stamp: 'cwp 2/17/2004 18:43'!
setMetaNode: aMetaNode node: aNode
	columns _ OrderedCollection with: (OBColumn 
										inBrowser: self 
										metaNode: aMetaNode
										node: aNode).
	minPanes _ 1! !

!OBBrowser methodsFor: 'accessing' stamp: 'cwp 2/11/2004 23:34'!
pushColumn: aColumn
	columns addLast: aColumn.
	self scroller pushPane: aColumn morph.
! !

!OBBrowser methodsFor: 'callbacks' stamp: 'cwp 1/30/2004 00:51'!
accept: aText notifying: aController
	| column |
	column _ self currentColumn ifNil: [^ self].
	[column accept: aText notifying: aController]
		on: OBNotification
		do: [:notification | notification notify: self].
	self changed: #text.! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 2/7/2004 23:14'!
browsePackage: aString
	^ self 
		browse: #Package 
		fromRoot: (OBPackageNode on: (OBPackageContext named: aString))
		minPanes: 4! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 2/8/2004 01:41'!
browsePackages
	^ self 
		browse: #System
		fromRoot: (OBSystemNode on: OBImageContext new)
		minPanes: 5! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 2/9/2004 19:40'!
browseImage
	^ self 
		browse: #Image
		fromRoot: (OBSystemNode on: OBImageContext new)
		minPanes: 4
! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 2/11/2004 22:25'!
nodeChanged
	self changed: #text! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 12/10/2003 22:51'!
open
	^ self window openInWorld! !

!OBBrowser class methodsFor: 'initialize-release' stamp: 'cwp 12/18/2003 18:11'!
initialize
	MetaGraphs _ Dictionary new! !

!OBBrowser class methodsFor: 'instance creation' stamp: 'cwp 2/17/2004 18:20'!
browse: aSymbol fromRoot: aNode
	| browser |
	browser _ self metaNode: ( self metaGraphAt: aSymbol) node: aNode.
	browser open.
	^ browser
! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 11/23/2003 18:02'!
label
	^ 'OmniBrowser'! !

!OBBrowser methodsFor: 'accessing' stamp: 'cwp 2/17/2004 18:43'!
minPanes: anInteger
	minPanes _ anInteger.
	(minPanes - (columns size)) timesRepeat: [self pushColumn: self emptyColumn]! !

!OBBrowser methodsFor: 'navigating' stamp: 'cwp 2/16/2004 22:16'!
jumpToRoot
	^ columns first selection: 0! !

!OBBrowser methodsFor: 'accessing' stamp: 'cwp 1/26/2004 21:46'!
currentColumn
	^ columns reversed detect: [:ea | ea selection > 0] ifNone: []
! !

!OBBrowser methodsFor: 'testing' stamp: 'cwp 1/31/2004 10:26'!
hasMorphs
	^ scroller notNil! !

!OBBrowser methodsFor: 'navigating' stamp: 'cwp 2/7/2004 15:57'!
root
	^ columns first parent! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 1/31/2004 10:21'!
browseFileSystem
	^ self 
		browse: #FileSystem
		fromRoot: (OBDirectoryNode on: FileDirectory root)
		select: (OBDirectoryNode default).
! !

!OBBrowser class methodsFor: 'instance creation' stamp: 'cwp 2/17/2004 18:45'!
browse: aSymbol fromRoot: aNode minPanes: anInteger
	| browser |
	browser _ self metaNode: (self metaGraphAt: aSymbol) node: aNode.
	browser 
		minPanes: anInteger;
		open.
	^ browser! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 2/17/2004 18:24'!
metaGraphAt: aSymbol
	^ MetaGraphs at: aSymbol ifAbsent: [self metaGraphMissing: aSymbol]! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 1/29/2004 23:51'!
textPane
	^ PluggableTextMorph
		on: self
		text: #text
		accept: #accept:notifying:! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 2/11/2004 23:39'!
selected: aColumn
	| count |
	count _ columns indexOf: aColumn.
	aColumn shouldBeLast ifFalse: [count _ count + 1].
	self trimColumnsTo: count
! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 2/17/2004 18:43'!
trimColumnsTo: anInteger
	| count |
	count _ self minPanes max: anInteger.
	columns size - count timesRepeat: [self popColumn].
! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 12/18/2003 18:13'!
metaGraphAt: aSymbol put: aMetaGraph
	MetaGraphs at: aSymbol put: aMetaGraph! !

!OBBrowser methodsFor: 'accessing' stamp: 'cwp 1/26/2004 21:47'!
currentNode
	^ self currentColumn ifNotNilDo: [:column | column selectedNode]! !

!OBBrowser methodsFor: 'accessing' stamp: 'cwp 2/17/2004 18:45'!
size: anInteger
	self scroller sizing: anInteger! !

Object subclass: #OBMetaNode
	instanceVariableNames: 'nodeClass filterClass edges actors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBMetaNode methodsFor: 'children' stamp: 'cwp 2/7/2004 22:44'!
children
	^ edges collect: [:edge | edge metaNode]! !

!OBMetaNode methodsFor: 'filtering' stamp: 'cwp 2/9/2004 21:02'!
filterClass: aClass
	filterClass _ aClass! !

!OBMetaNode methodsFor: 'initializing' stamp: 'cwp 2/7/2004 22:38'!
setNodeClass: aNodeClass
	nodeClass _ aNodeClass.
	edges _ OrderedCollection new.
	actors _ OrderedCollection new.! !

!OBMetaNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 17:45'!
for: aNodeClass
	^ self new setNodeClass: aNodeClass! !

!OBMetaNode methodsFor: 'filtering' stamp: 'cwp 2/9/2004 21:26'!
filter
	filterClass ifNil: [filterClass _ OBFilter].
	^ filterClass forMetaNode: self! !

!OBMetaNode methodsFor: 'nodes' stamp: 'cwp 2/9/2004 21:18'!
nodesForParent: aNode
	^ (self ownsNode: aNode)
		ifTrue: [edges gather: [:edge | edge nodesForParent: aNode]]
		ifFalse: [#()]! !

!OBMetaNode methodsFor: 'children' stamp: 'cwp 2/7/2004 22:38'!
hasChildren
	^ edges isEmpty not! !

!OBMetaNode methodsFor: 'children' stamp: 'cwp 2/7/2004 22:35'!
childAt: aSelector put: aMetaNode
	edges add: (OBMetaEdge selector: aSelector metaNode: aMetaNode)! !

!OBMetaNode methodsFor: 'metagraph' stamp: 'cwp 2/9/2004 21:12'!
edges
	^ edges! !

!OBMetaNode methodsFor: 'children' stamp: 'cwp 2/9/2004 21:16'!
childFor: aNode
	^ (edges detect: [:e | e metaNode ownsNode: aNode]) metaNode! !

!OBMetaNode methodsFor: 'actors' stamp: 'cwp 2/5/2004 20:15'!
actionsForParent: aNode
	^ actors gather: [:actor | actor actionsForParent: aNode]! !

!OBMetaNode methodsFor: 'filtering' stamp: 'cwp 2/9/2004 21:00'!
metaNode
	^ self! !

!OBMetaNode methodsFor: 'actors' stamp: 'cwp 1/23/2004 23:25'!
actionsForNode: aNode
	^ actors gather: [:actor | actor actionsForNode: aNode]! !

!OBMetaNode methodsFor: 'nodes' stamp: 'cwp 12/18/2003 20:48'!
nodeClass
	^ nodeClass! !

!OBMetaNode methodsFor: 'nodes' stamp: 'cwp 2/16/2004 20:43'!
ownsNode: aNode
	^ aNode isKindOf: nodeClass! !

!OBMetaNode methodsFor: 'children' stamp: 'cwp 2/9/2004 20:28'!
childAt: aSelector labeled: aString put: aMetaNode
	edges add: (OBMetaEdge label: aString selector: aSelector metaNode: aMetaNode)! !

!OBMetaNode methodsFor: 'actors' stamp: 'cwp 2/5/2004 20:18'!
addActor: anActor
	anActor attachToMetaNode: self.
	actors add: anActor.! !

!OBMetaNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:34'!
on: aNodeClass
	^ self new setNodeClass: aNodeClass! !

Object subclass: #OBFakeClassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Fakes'!

Object subclass: #OBNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBNode methodsFor: 'public' stamp: 'cwp 1/31/2004 14:57'!
hash
	^ self name hash! !

!OBNode methodsFor: 'public' stamp: 'cwp 1/30/2004 23:20'!
accept: aText notifying: aController
	self text: aText! !

!OBNode methodsFor: 'public' stamp: 'cwp 1/31/2004 14:57'!
= other
	^ self class = other class and: [self name = other name]! !

!OBNode methodsFor: 'public' stamp: 'cwp 12/10/2003 22:27'!
name
	self subclassResponsibility! !

OBNode subclass: #OBClassCreatingNode
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

OBClassCreatingNode subclass: #OBClassCategoryNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBClassCategoryNode methodsFor: 'class creation' stamp: 'cwp 1/29/2004 23:43'!
subclassDefiner
	^ nil subclassDefinerClass! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'cwp 2/25/2004 22:42'!
rename
	| category |
	category _ OBTextRequest
				prompt: 'Please type new category name' 
				template: name.
	category ifNotNil:	[context renameCategory: name toBe: category.
						name _ category.
						OBListChanged signal]! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'cwp 2/5/2004 20:20'!
actions
	^ Array
		with: (self action: #remove withLabel: 'remove')
		with: (self action: #rename withLabel: 'rename...')! !

!OBClassCategoryNode class methodsFor: 'instance creation' stamp: 'cwp 12/10/2003 23:17'!
on: aString inContext: aCodeContext
	^ self new setName: aString context: aCodeContext! !

!OBClassCategoryNode class methodsFor: 'actions' stamp: 'cwp 2/25/2004 22:40'!
createInContext: aContext
	| catName |
	catName _ OBTextRequest 
					prompt: 'Please type new category name' 
					template: 'Category-Name'.
	catName ifNotNil:	[aContext addCategory: catName.
						(OBClassCategoryNode 
							on: catName 
							inContext: aContext) signalSelection]! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'cwp 2/25/2004 22:41'!
remove
	context removeCategory: name.
	OBNodeDeleted signal.! !

!OBClassCategoryNode methodsFor: 'navigation' stamp: 'cwp 2/2/2004 21:47'!
classCategoryNode
	^ self! !

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 12/17/2003 18:16'!
classes
	^ (context classesInCategory: name) 
		collect: [:class | OBClassNode on: class inContext: context]! !

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 2/7/2004 20:53'!
metaclasses
	^ (context classesInCategory: name) 
		collect: [:class | OBMetaclassNode on: class inContext: context]! !

!OBClassCategoryNode methodsFor: 'drag and drop' stamp: 'cwp 2/25/2004 22:38'!
acceptDroppedNode: aNode
	context setCategoryOf: aNode symbol to: name.
	self signalSelection! !

!OBClassCategoryNode methodsFor: 'drag and drop' stamp: 'avi 2/20/2004 14:38'!
wantsDroppedNode: aNode
	^ aNode isKindOf: OBClassNode! !

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 1/29/2004 23:06'!
text
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', (context longNameOf: name), ''''! !

!OBClassCategoryNode class methodsFor: 'actions' stamp: 'cwp 2/5/2004 20:34'!
actionsForParent: aNode
	^ Array
		with: (OBAction 
				label: 'create category...'
				receiver: self
				selector: #createInContext:
				arguments: (Array with: aNode context))
		! !

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 2/25/2004 01:18'!
comments
	^ (context classesInCategory: name) 
		collect: [:class | OBClassCommentNode on: class inContext: context]! !

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 12/10/2003 23:18'!
name
	^ name! !

!OBClassCategoryNode methodsFor: 'initializing' stamp: 'cwp 12/14/2003 21:08'!
setName: aString context: aCodeContext
	name _ aString.
	context _ aCodeContext.
! !

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 2/2/2004 21:46'!
isAncestorOf: aNode
	^ aNode classCategoryNode name = name
! !

!OBClassCreatingNode methodsFor: 'class creation' stamp: 'cwp 2/25/2004 22:38'!
defineClass: definition notifying: aController
	| newClass |
	newClass _ self subclassDefiner 
					evaluate: definition 
					notifying: aController
					logged: true.
	newClass isMeta ifFalse: [(OBClassNode 
								on: newClass name 
								inContext: context) signalSelection].
	
! !

!OBClassCreatingNode methodsFor: 'public' stamp: 'cwp 1/31/2004 14:18'!
context
	^ context! !

OBClassCreatingNode subclass: #OBClassNode
	instanceVariableNames: 'className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/9/2004 20:13'!
theClass
	^ context classNamed: className! !

!OBClassNode methodsFor: 'nodes' stamp: 'cwp 2/7/2004 15:08'!
classCategoryNode
	^ OBClassCategoryNode on: (context categoryOf: className) inContext: context! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/7/2004 15:10'!
name
	^ className asString! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/7/2004 17:02'!
symbol
	^ className! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/16/2004 20:42'!
categories
	^ ((context categoriesForClass: className)
		collect: [:cat | OBMethodCategoryNode on: cat inClass: className inContext: context])
			copyWithFirst: self allCategory! !

!OBClassNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:15'!
on: className inContext: aCodeContext
	^ self new setClassName: className context: aCodeContext! !

!OBClassNode methodsFor: 'nodes' stamp: 'cwp 1/30/2004 01:01'!
classNode 
	^ self! !

OBClassNode subclass: #OBMetaclassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMetaclassNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 21:33'!
name 
	^ self nonMetaName! !

!OBMetaclassNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 21:32'!
nonMetaName
	^ (className allButLast: 6) asSymbol! !

!OBMetaclassNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 21:24'!
setClassName: aSymbol context: aCodeContext
	super 
		setClassName: (aSymbol, ' class') asSymbol
		context: aCodeContext! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 2/7/2004 15:05'!
remove
	context removeClass: className.
	OBNodeDeleted signal.! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/7/2004 15:08'!
text
	^ self theClass definition! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/7/2004 15:09'!
isAncestorOf: aNode
	^ aNode classNode name asSymbol = className! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 2/5/2004 23:52'!
actions
	^ Array
		with: (self action: #rename withLabel: 'rename...')
		with: (self action: #remove withLabel: 'remove')! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/16/2004 20:41'!
allCategory
	^ OBAllMethodCategoryNode on: className inContext: context! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 2/25/2004 22:38'!
rename
	| newName |
	newName _ OBTextRequest
				prompt: 'Please type new class name' 
				template: className asString.
	newName ifNotNil:	[context renameClass: className toBe: newName asSymbol.
						self signalSelection]! !

!OBClassNode methodsFor: 'class creation' stamp: 'cwp 2/7/2004 15:09'!
subclassDefiner
	^ self theClass superclass subclassDefinerClass! !

!OBClassNode methodsFor: 'initializing' stamp: 'cwp 2/7/2004 15:06'!
setClassName: aSymbol context: aCodeContext
	className _ aSymbol.
	context _ aCodeContext! !

!OBClassCreatingNode methodsFor: 'public' stamp: 'cwp 1/30/2004 23:32'!
accept: definition notifying: aController
	self defineClass: definition notifying: aController! !

!OBNode methodsFor: 'utility' stamp: 'cwp 2/3/2004 22:29'!
action: aSelector withLabel: aString
	^ OBAction
		label: aString
		receiver: self
		selector: aSelector
		arguments: #()! !

!OBNode methodsFor: 'drag and drop' stamp: 'avi 2/20/2004 14:00'!
asDraggableMorph
	^(StringMorph contents: self name)
		color: Color white;
		yourself! !

!OBNode methodsFor: 'utility' stamp: 'cwp 2/25/2004 22:37'!
signalSelection
	^ (OBNodeSelected for: self) signal! !

OBNode subclass: #OBClassCommentNode
	instanceVariableNames: 'className context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBClassCommentNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/25/2004 01:19'!
name
	^ className asString! !

!OBClassCommentNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/25/2004 01:36'!
text: aText
	context setCommentForClass: className to: aText ! !

!OBClassCommentNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/25/2004 01:20'!
text
	^ context commentForClass: className! !

!OBClassCommentNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/25/2004 01:08'!
on: className inContext: aContext
	^ self new setClassName: className context: aContext! !

!OBClassCommentNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/25/2004 01:08'!
setClassName: aSymbol context: aContext
	className _ aSymbol.
	context _ aContext! !

OBNode subclass: #OBPackageNode
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 13:52'!
categories
	^ context categories collect: [:cat | OBClassCategoryNode on: cat inContext: context]! !

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 13:53'!
package
	^ context package! !

!OBPackageNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:58'!
on: aPackage
	^ self new context: (OBPackageContext on: aPackage)! !

!OBPackageNode methodsFor: 'public' stamp: 'cwp 2/7/2004 14:02'!
isAncestorOf: aNode
	^ context package packageName = aNode context package packageName! !

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 13:52'!
classes
	^ context classes collect: [:class | OBClassNode on: class inContext: context]! !

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 13:49'!
context
	^ context! !

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 13:50'!
context: aCodeContext
	context _ aCodeContext! !

!OBPackageNode methodsFor: 'public' stamp: 'cwp 2/7/2004 13:49'!
name
	^ context package packageName! !

!OBNode methodsFor: 'public' stamp: 'cwp 1/30/2004 23:23'!
text: aText
	! !

!OBNode methodsFor: 'drag and drop' stamp: 'avi 2/20/2004 14:37'!
acceptDroppedNode: aNode
	^ false! !

OBNode subclass: #OBDictionaryNode
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBDictionaryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:01'!
on: aDictionary
	^ self new dictionary: aDictionary! !

!OBDictionaryNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:13'!
associations
	^ dictionary keys asArray 
		collect: [:key | OBAssociationNode key: key value: (dictionary at: key)]! !

!OBDictionaryNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:00'!
dictionary: aDictionary
	dictionary _ aDictionary! !

OBNode subclass: #OBAssociationNode
	instanceVariableNames: 'key value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBAssociationNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:14'!
key: keyObject value: valueObject
	^ self new setKey: keyObject value: valueObject! !

!OBAssociationNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:15'!
name
	^ key! !

!OBAssociationNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:13'!
value
	^ value! !

!OBAssociationNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:10'!
setKey: keyObject value: valueObject
	key _ keyObject.
	value _ valueObject.! !

OBNode subclass: #OBFakeNode
	instanceVariableNames: 'item parent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFakeNode methodsFor: 'public' stamp: 'cwp 1/23/2004 21:42'!
children
	^ children 
		ifNil: [children _ (self item endsWith: 'c')
					ifTrue: [Array new]
					ifFalse: [#($a $b $c) collect: [:i | OBFakeNode parent: self item: i asString]]]! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 2/25/2004 21:53'!
removeChild: aFakeNode
	children _ self children copyWithout: aFakeNode! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 1/7/2004 09:29'!
beZ
	item _ 'z'! !

!OBFakeNode methodsFor: 'drag and drop' stamp: 'cwp 2/25/2004 21:44'!
acceptDroppedNode: aNode
	self adopt: aNode! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/15/2003 22:01'!
parent: aFakeNode
	parent _ aFakeNode! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 2/25/2004 22:39'!
adopt: aNode
	aNode parent removeChild: aNode.
	aNode parent: self.
	children _ self children copyWith: aNode.
	self signalSelection! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 2/25/2004 22:42'!
delete
	parent ifNotNil: [parent removeChild: self].
	OBNodeDeleted signal.	! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 2/25/2004 22:06'!
isAncestorOf: aNode
	| ancestor |
	ancestor _ aNode.
	[ancestor isNil]
		whileFalse: [ancestor == self ifTrue: [^ true].
					ancestor _ ancestor parent].
	^ false! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/7/2003 19:09'!
item: aSymbol
	item _ aSymbol! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 2/3/2004 22:30'!
actions
	^ Array 
		with: (self action: #beZ withLabel: 'become z')
		with: (self action: #delete withLabel: 'delete')! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:05'!
name
	^ self parentName, self item ! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 2/25/2004 21:49'!
parent
	^ parent! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/15/2003 22:04'!
parentName
	^ (parent ifNil: [''] ifNotNil: [parent name])! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:04'!
text: aText
	self item:( aText asString allButFirst: (self parentName size))! !

!OBFakeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 22:06'!
parent: aFakeNode item: aString
	^ self new parent: aFakeNode; item: aString! !

!OBFakeNode methodsFor: 'drag and drop' stamp: 'cwp 2/25/2004 21:43'!
wantsDroppedNode: aNode
	^ aNode isKindOf: self class! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/7/2003 19:18'!
item
	^ item ifNil: [item _ '']! !

!OBFakeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:31'!
metaGraph
	| fake |
	fake _ OBMetaNode for: OBFakeNode.
	fake 
		childAt: #children put: fake;
		addActor: OBNodeActor new.
	^ fake! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:03'!
text
	^ self name! !

OBNode subclass: #OBFileNode
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBFileNode methodsFor: 'public' stamp: 'cwp 12/8/2003 22:20'!
text: aText
	| file |
	file _ self openFile.
	file
		reset;
		nextPutAll: aText asString;
		truncate: (file position);
		close! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 12/8/2003 22:21'!
openFile
	^ FileStream oldFileNamed: path! !

!OBFileNode methodsFor: 'comparing' stamp: 'cwp 1/31/2004 14:58'!
hash
	^ self path hash! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 12/7/2003 20:00'!
name
	^ FileDirectory localNameFor: path! !

!OBFileNode class methodsFor: 'instance creation' stamp: 'cwp 12/7/2003 19:43'!
on: aPath
	^ self new path: aPath! !

!OBFileNode methodsFor: 'accessing' stamp: 'cwp 12/7/2003 19:44'!
path: aPath
	path _ aPath! !

!OBFileNode methodsFor: 'comparing' stamp: 'cwp 1/31/2004 14:58'!
= other
	^ self path = other path! !

!OBFileNode methodsFor: 'actions' stamp: 'cwp 2/25/2004 22:42'!
delete
	FileDirectory deleteFilePath: path.
	OBNodeDeleted signal.	! !

!OBFileNode methodsFor: 'accessing' stamp: 'cwp 1/24/2004 00:16'!
path
	^ path! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 2/3/2004 22:30'!
actions
	^ Array with: (self action: #delete withLabel: 'delete')! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 2/12/2004 20:52'!
text
	| file text |
	file _ self openFile.
	file ifNil: [^ 'Error opening file'].
	text _ file contentsOfEntireFile.
	file close.
	^ text! !

OBNode subclass: #OBMetaNodeNode
	instanceVariableNames: 'metaNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMetaNodeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:32'!
metaNode: aMetaNode
	metaNode _ aMetaNode! !

!OBMetaNodeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:15'!
children
	^ metaNode children collect: [:mn | OBMetaNodeNode on: mn]! !

!OBMetaNodeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:58'!
name
	^ metaNode nodeClass name! !

!OBMetaNodeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:15'!
on: aMetaNode
	^ self new metaNode: aMetaNode! !

!OBMetaNodeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:26'!
text
	^ 'OBMetaNode on: ', metaNode nodeClass name! !

!OBNode methodsFor: 'public' stamp: 'cwp 1/30/2004 00:52'!
isAncestorOf: aNode
	^ false! !

OBNode subclass: #OBSystemNode
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:22'!
packages
	^ context packages collect: [:aPackage | OBPackageNode on: aPackage]! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:58'!
context
	^ context! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:26'!
categories
	^ context categories collect: [:cat | OBClassCategoryNode on: cat inContext: context]! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2004 06:21'!
name 
	^ 'Squeak'! !

!OBSystemNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:19'!
on: aCodeContext
	^ self new context: aCodeContext! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:18'!
context: aCodeContext
	context _ aCodeContext! !

!OBNode methodsFor: 'public' stamp: 'cwp 12/7/2003 19:27'!
text
	^ ''! !

!OBNode methodsFor: 'drag and drop' stamp: 'avi 2/20/2004 14:31'!
wantsDroppedNode: aNode
	^ false! !

!OBNode methodsFor: 'public' stamp: 'cwp 1/7/2004 09:25'!
actions
	^ #()! !

!OBNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:11'!
fromAssociation: anAssociationNode
	^ self on: anAssociationNode value! !

OBNode subclass: #OBMethodCreatingNode
	instanceVariableNames: 'className context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMethodCreatingNode methodsFor: 'public' stamp: 'cwp 1/31/2004 09:51'!
accept: aText notifying: aController
	self compileMethod: aText notifying: aController
	! !

!OBMethodCreatingNode methodsFor: 'navigation' stamp: 'cwp 2/7/2004 15:20'!
classCategoryNode
	^ OBClassCategoryNode on: (context categoryOf: className) inContext: context! !

!OBMethodCreatingNode methodsFor: 'method creation' stamp: 'cwp 2/7/2004 15:20'!
methodNodeFor: aSelector
	^ OBMethodNode 
		on: (self referenceForMethod: aSelector ofClass: className)
		inContext: context! !

!OBMethodCreatingNode methodsFor: 'public' stamp: 'cwp 2/9/2004 20:14'!
theClass
	^ context classNamed: className! !

OBMethodCreatingNode subclass: #OBMethodNode
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMethodNode methodsFor: 'initializing' stamp: 'cwp 2/8/2004 13:12'!
setReference: aMethodReference context: aCodeContext
	className _ aMethodReference classSymbol.
	aMethodReference classIsMeta ifTrue: [className _ (className, ' class') asSymbol].
	self 
		setSelector: aMethodReference methodSymbol
		class: className
		context: aCodeContext! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 2/8/2004 12:59'!
implementors
	^ (context allImplementorsOf: selector) 
			collect: [:ref | OBNakedMethodNode on: ref inContext: context]! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/20/2004 17:22'!
chaseSenders
	OBBrowser 
		browse: #ChaseSenders 
		fromRoot: self
		minPanes: 3! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/7/2004 19:04'!
remove
	context removeMethod: selector fromClass: className.
	OBNodeDeleted signal! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 1/31/2004 00:50'!
isAncestorOf: aNode
	^ self class = aNode class and: [self name = aNode name]! !

!OBMethodNode methodsFor: 'public' stamp: 'cwp 1/31/2004 09:53'!
name
	^ selector! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 2/8/2004 14:25'!
selector
	^ selector! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 15:21'!
category
	^ context methodCategoryOf: self reference! !

!OBMethodNode methodsFor: 'initializing' stamp: 'cwp 2/7/2004 16:02'!
setSelector: aSelector class: aSymbol context: aCodeContext
	className _ aSymbol.
	selector _ aSelector.
	context _ aCodeContext! !

!OBMethodNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 16:03'!
on: aSelector inClass: aSymbol inContext: aCodeContext
	^ self new setSelector: aSelector class: aSymbol context: aCodeContext! !

OBMethodNode subclass: #OBNakedMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBNakedMethodNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 13:13'!
name
	^ className, '>>', selector ! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/9/2004 23:09'!
browseImplementors
	OBBrowser browse: #Implementors fromRoot: self selectMessage! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 2/20/2004 17:14'!
selectorAndMessages
	^ self messages copyWithFirst: self selectorNode! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/9/2004 23:39'!
selectMessage
	| messages |
	messages _ (context messagesSentBy: selector inClass: className) copyWithFirst: selector.
	selector _ (OBChoiceRequest options: messages).
	^ OBSelectorNode on: selector inContext: context! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 2/20/2004 17:14'!
messages
	^ (context messagesSentBy: selector inClass: className)
		collect: [:sel | OBSelectorNode on: sel inContext: context]! !

!OBMethodNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 23:51'!
on: aMethodReference inContext: aCodeContext
	^ self new setReference: aMethodReference context: aCodeContext! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/9/2004 23:02'!
actions
	^ Array
		with: (self action: #remove withLabel: 'remove')
		with: (self action: #browseImplementors withLabel: 'browse implementors...')
		with: (self action: #browseSenders withLabel: 'browse senders...')
		with: (self action: #chaseImplementors withLabel: 'chase implementors')
		with: (self action: #chaseSenders withLabel: 'chase senders')! !

!OBMethodNode methodsFor: 'public' stamp: 'cwp 2/7/2004 15:21'!
text
	^ self reference source! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 2/7/2004 15:21'!
methodCategoryNode
	^ OBMethodCategoryNode 
		on: self category
		inClass: className
		inContext: context! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/20/2004 17:18'!
chaseImplementors
	OBBrowser 
		browse: #ChaseImplementors 
		fromRoot: self
		minPanes: 3! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 15:20'!
reference
	^ self referenceForMethod: selector ofClass: className! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/9/2004 23:09'!
browseSenders
	OBBrowser browse: #Senders fromRoot: self selectMessage! !

!OBMethodNode methodsFor: 'comparing' stamp: 'cwp 2/8/2004 14:26'!
= other
	^ (other isKindOf: OBMethodNode)
		and: [self className = self className] 
		and: [self selector = other selector]! !

!OBMethodNode methodsFor: 'nodes' stamp: 'cwp 2/8/2004 13:41'!
selectorNode
	^ OBSelectorNode on: selector inContext: context! !

OBMethodCreatingNode subclass: #OBMethodCategoryNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMethodCategoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:16'!
on: aString inClass: className inContext: aCodeContext
	^ self new setName: aString class: className context: aCodeContext! !

!OBMethodCategoryNode methodsFor: 'initializing' stamp: 'cwp 2/7/2004 15:28'!
setName: aString class: aSymbol context: aCodeContext
	name _ aString.
	className _ aSymbol.
	context _ aCodeContext! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'cwp 2/7/2004 10:59'!
actions
	^ Array
		with: (self action: #remove withLabel: 'remove')
		with: (self action: #rename withLabel: 'rename...')! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'cwp 2/25/2004 22:42'!
rename
	| category |
	category _ OBTextRequest
				prompt: 'Please type new category name' 
				template: name.
	category ifNotNil:	[context renameCategory: name inClass: className toBe: category.
						name _ category.
						OBListChanged signal]! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 1/30/2004 23:45'!
text
	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!OBMethodCategoryNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 15:27'!
methodReferences
	^ context methodsInCategory: name ofClass: className! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 12/10/2003 23:10'!
name
	^ name! !

!OBMethodCategoryNode methodsFor: 'accessing' stamp: 'cwp 1/31/2004 09:52'!
category
	^ name! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'cwp 2/7/2004 15:52'!
remove
	context removeCategory: name fromClass: className.
	OBNodeDeleted signal! !

!OBMethodCategoryNode methodsFor: 'children' stamp: 'cwp 12/17/2003 18:25'!
methods
	^ self methodReferences collect: [:ref | OBMethodNode on: ref inContext: context]! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 2/7/2004 15:28'!
isAncestorOf: aNode
	^ className = aNode classNode name asSymbol
		and: [name = aNode methodCategoryNode name]! !

!OBMethodCategoryNode methodsFor: 'navigation' stamp: 'cwp 2/7/2004 16:13'!
methodCategoryNode
	^ self! !

!OBMethodCategoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 10:34'!
actionsForParent: aNode
	^ Array with: (OBAction
					label: 'create category...'
					receiver: self
					selector: #createInClass:
					arguments: (Array with: aNode))! !

OBMethodCategoryNode subclass: #OBAllMethodCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBAllMethodCategoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2004 20:39'!
on: className inContext: aCodeContext
	^ self on: '-- all --' inClass: className inContext: aCodeContext! !

!OBAllMethodCategoryNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2004 20:38'!
methodReferences
	^ context methodsForClass: className! !

!OBMethodCategoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/25/2004 22:40'!
createInClass: aClassNode
	| catName |
	catName _ OBTextRequest 
					prompt: 'Please type new category name' 
					template: ''.
	catName ifNotNil:	[aClassNode context addCategory: catName toClass: aClassNode name.
						(OBMethodCategoryNode 
							on: catName 
							inClass: aClassNode symbol
							inContext: aClassNode context) signalSelection]! !

!OBMethodCreatingNode methodsFor: 'method creation' stamp: 'cwp 2/25/2004 22:39'!
compileMethod: aText notifying: aController
	| selector |
	selector _ self theClass compile: aText asString classified: self category notifying: aController.
	selector ifNotNil: [(self methodNodeFor: selector) signalSelection]! !

!OBMethodCreatingNode methodsFor: 'navigation' stamp: 'cwp 2/7/2004 16:12'!
classNode
	^ OBClassNode on: className inContext: context! !

!OBMethodCreatingNode methodsFor: 'public' stamp: 'cwp 1/31/2004 14:18'!
context
	^ context! !

!OBNode methodsFor: 'utility' stamp: 'cwp 2/7/2004 21:29'!
referenceForMethod: selector ofClass: className
	| classIsMeta symbol |
	classIsMeta _ className endsWith: ' class'.
	symbol _ classIsMeta ifTrue: [(className allButLast: 6) asSymbol] ifFalse: [className].
	^ MethodReference new 
		setClassSymbol: symbol
		classIsMeta: classIsMeta
		methodSymbol: selector
		stringVersion: symbol, '>>', selector! !

!OBNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 20:25'!
actionsForParent: aNode
	^ #()! !

OBNode subclass: #OBDirectoryNode
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBDirectoryNode methodsFor: 'public' stamp: 'cwp 12/7/2003 19:51'!
name
	^ directory localName! !

!OBDirectoryNode methodsFor: 'accessing' stamp: 'cwp 1/31/2004 10:15'!
path
	^ directory fullName! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 12/15/2003 21:37'!
nodeForEntry: anEntry
	^ (anEntry at: 4)
		ifTrue: [OBDirectoryNode on: (directory directoryNamed: (anEntry at: 1))]
		ifFalse: [OBFileNode on: (directory fullNameFor: (anEntry at: 1))]! !

!OBDirectoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2003 21:57'!
on: aFileDirectory
	^ self new directory: aFileDirectory! !

!OBDirectoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2004 10:17'!
default
	^ self on: (FileDirectory default)! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 12/6/2003 17:43'!
textForDirectory: aFilename
	| entry |
	entry _ directory entryAt: aFilename.
	^ String streamContents: [:stream |
			stream 
				nextPutAll: 'Directory: '; 
				nextPutAll: (directory fullNameFor: aFilename); cr;
				nextPutAll: 'Created: '; nextPutAll: (entry at: 2) asString; cr;
				nextPutAll: 'Modified: '; nextPutAll: (entry at: 3) asString; cr;
				nextPutAll: 'Size: '; nextPutAll: (entry at: 5) asString; cr;
				cr; nextPutAll: '----------'; cr.

			directory entries do: [:e | self displayEntry: e on: stream]

	]! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 11/28/2003 21:57'!
directory: aFileDirectory
	directory _ aFileDirectory! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 1/31/2004 15:15'!
shouldDisplay: name
	^ name first ~= $.! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 12/6/2003 18:01'!
displayEntry: entry on: aStream
	aStream nextPutAll: (entry at: 1).
	aStream nextPutAll: ' - '.
	aStream nextPutAll: (entry at: 5) asString, ' bytes'.
	aStream cr.! !

!OBDirectoryNode methodsFor: 'comparing' stamp: 'cwp 1/31/2004 14:59'!
hash
	^ self path hash! !

!OBDirectoryNode methodsFor: 'children' stamp: 'cwp 1/31/2004 15:14'!
files
	^ directory fileNames 
		select: [:name | self shouldDisplay: name]
		thenCollect: [:name | OBFileNode on: (directory fullNameFor: name)]
	! !

!OBDirectoryNode methodsFor: 'public' stamp: 'cwp 1/31/2004 10:14'!
isAncestorOf: aNode
	^ aNode path beginsWith: self path! !

!OBDirectoryNode methodsFor: 'comparing' stamp: 'cwp 1/31/2004 14:59'!
= other
	^ self path = other path! !

!OBDirectoryNode methodsFor: 'children' stamp: 'cwp 1/31/2004 15:14'!
directories
	^ directory directoryNames 
		select: [:name | self shouldDisplay: name]
		thenCollect: [:name | OBDirectoryNode on: (directory directoryNamed: name)]
	! !

!OBDirectoryNode methodsFor: 'public' stamp: 'cwp 12/7/2003 19:47'!
text
	| entry |
	entry _ directory directoryEntry.
	^ String streamContents: [:stream |
			stream 
				nextPutAll: 'Directory: '; 
				nextPutAll: (directory fullNameFor: (entry at: 1)); cr;
				nextPutAll: 'Created: '; nextPutAll: (entry at: 2) asString; cr;
				nextPutAll: 'Modified: '; nextPutAll: (entry at: 3) asString; cr;
				nextPutAll: 'Size: '; nextPutAll: (entry at: 5) asString; cr;
				cr; nextPutAll: '----------'; cr.

			directory entries do: [:e | self displayEntry: e on: stream]

	]! !

OBNode subclass: #OBSelectorNode
	instanceVariableNames: 'selector context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBSelectorNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:34'!
name
	^ selector asString! !

!OBSelectorNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 13:00'!
implementors
	^ (context allImplementorsOf: selector) 
			collect: [:ref | OBNakedMethodNode on: ref inContext: context]! !

!OBSelectorNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:25'!
setSelector: aSelector context: aCodeContext
	selector _ aSelector.
	context _ aCodeContext.! !

!OBSelectorNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:33'!
selector
	^ selector! !

!OBSelectorNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 13:16'!
senders
	^ (context allSendersOf: selector) 
			collect: [:ref | OBNakedMethodNode on: ref inContext: context]! !

!OBSelectorNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:25'!
on: aSelector inContext: aCodeContext
	^ self new setSelector: aSelector context: aCodeContext! !

Object subclass: #OBImageContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Utilities'!

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 2/7/2004 14:48'!
removeCategory: aString fromClass: className 
	(self classNamed: className) organization removeCategory: aString! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/3/2004 22:42'!
removeCategory: aString
	SystemOrganization removeSystemCategory: aString! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 2/7/2004 14:39'!
renameClass: oldName toBe: newName
	Smalltalk renameClassNamed: oldName as: newName! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 1/31/2004 13:29'!
longNameOf: classCategory
	^ classCategory! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 2/25/2004 01:47'!
setCommentForClass: className to: aText
	^ (self classNamed: className) comment: aText! !

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 2/13/2004 00:03'!
categoriesForClass: className
	^ (self classNamed: className) organization categories! !

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 2/7/2004 15:32'!
addCategory: aString toClass: className 
	(self classNamed: className asSymbol) organization addCategory: aString! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/9/2004 20:08'!
categoryOf: className
	^ (self classNamed: className) theNonMetaClass category! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 2/7/2004 15:26'!
methodsInCategory: catName ofClass: className
	^ ((self classNamed: className)
		 organization listAtCategoryNamed: catName)
		 	collect: [:sel | self referenceForMethod: sel ofClass: className]! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/2/2004 22:54'!
renameCategory: oldName toBe: newName
	SystemOrganization renameCategory: oldName toBe: newName! !

OBImageContext subclass: #OBPackageContext
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Utilities'!

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:11'!
classesInCategory: aString
	^ super classesInCategory: (package longNameOf: aString)! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:40'!
addCategory: aString
	super addCategory: (package longNameOf: aString)! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 14:49'!
categoryOf: className
	^ package shortNameOf: (super categoryOf: className)! !

!OBPackageContext class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:07'!
named: aString
	^ self on: (PackageInfo named: aString)! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:44'!
renameCategory: oldName toBe: newName
	super 
		renameCategory: (package longNameOf: oldName)
		toBe: (package longNameOf: newName)! !

!OBPackageContext methodsFor: 'private' stamp: 'cwp 2/7/2004 14:08'!
longNameOf: aString
	^ package longNameOf: aString! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:08'!
package: aPackage
	package _ aPackage! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:33'!
categories
	^ package systemCategories collect: [:cat | package shortNameOf: cat]! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:09'!
package
	^ package! !

!OBPackageContext class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:07'!
on: aPackageInfo
	^ self new package: aPackageInfo! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:45'!
removeCategory: aString
	super removeCategory: (package longNameOf: aString)! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 02:23'!
methodsForClass: className
	| class |
	class _ self classNamed: className.
	^ (package coreMethodsForClass: class), (package extensionMethodsForClass: class)! !

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 2/7/2004 14:48'!
renameCategory: oldName inClass: className toBe: newName 
	(self classNamed: className) organization renameCategory: oldName toBe: newName! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/7/2004 14:44'!
classesInCategory: aCategory
	^ SystemOrganization listAtCategoryNamed: aCategory asSymbol! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 2/25/2004 01:22'!
commentForClass: className
	^ (self classNamed: className) comment! !

!OBImageContext methodsFor: 'navigation' stamp: 'cwp 2/8/2004 13:18'!
allSendersOf: aSelector
	^ self systemNavigation allCallsOn: aSelector! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 2/7/2004 21:12'!
metaclassNamed: aSymbol
	^ (self classNamed: aSymbol) class! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 2/7/2004 14:59'!
methodsForClass: className
	^ (self classNamed: className)
		 selectors asArray collect: [:sel | self referenceForMethod: sel ofClass: className]! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 2/7/2004 14:36'!
removeClass: className
	(self classNamed: className) removeFromSystem.! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 2/7/2004 19:04'!
removeMethod: aSelector fromClass: className
	(self classNamed: className) removeSelector: aSelector! !

!OBImageContext methodsFor: 'navigation' stamp: 'cwp 2/8/2004 11:41'!
allImplementorsOf: aSelector
	^ self systemNavigation allImplementorsOf: aSelector! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 2/7/2004 21:25'!
classNamed: aString
	^ (aString endsWith: ' class')
		ifTrue: [self metaclassNamed: (aString allButLast: 6) asSymbol]
		ifFalse: [Smalltalk at: aString]! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 12/17/2003 20:40'!
categories
	^ SystemOrganization categories! !

!OBImageContext methodsFor: 'packages' stamp: 'cwp 12/17/2003 20:23'!
packages
	^ PackageInfo allPackages! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/25/2004 22:10'!
setCategoryOf: className to: catName
	(self classNamed: className) theNonMetaClass category: catName! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 2/7/2004 15:02'!
referenceForMethod: selector ofClass: className
	^ MethodReference new 
		setClassSymbol: className
		classIsMeta: false
		methodSymbol: selector
		stringVersion: className, '>>', selector! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/2/2004 21:17'!
addCategory: aString
	SystemOrganization addCategory: aString! !

!OBImageContext methodsFor: 'navigation' stamp: 'cwp 2/9/2004 22:48'!
messagesSentBy: aSelector inClass: aSymbol
	^ (((self classNamed: aSymbol) compiledMethodAt: aSelector) messages) asArray! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 1/31/2004 13:40'!
methodCategoryOf: aMethodReference
	^ aMethodReference actualClass organization 
		categoryOfElement: aMethodReference methodSymbol! !

Object subclass: #OBColumn
	instanceVariableNames: 'browser filter parent children selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/12/2004 18:47'!
filter: aFilter
	filter _ aFilter monitor: self.
	self changed: #filter.! !

!OBColumn methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:45'!
shouldBeLast
	^ self selection = 0 or: [self nextMetaNode hasChildren not]! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 2/11/2004 21:46'!
createNext
	| nextMetaNode created |
	nextMetaNode _ self nextMetaNode.
	created _ self class 
					inBrowser: browser
					metaNode: nextMetaNode
					node: self selectedNode.
	browser pushColumn: created.
	^ created! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 11/5/2003 19:01'!
selection
	^ selection ifNil: [0]! !

!OBColumn methodsFor: 'testing' stamp: 'cwp 2/12/2004 19:35'!
hasSelection
	^ selection ~= 0! !

!OBColumn methodsFor: 'printing' stamp: 'cwp 2/11/2004 23:31'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self descriptor.
	aStream nextPut: $)! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 2/25/2004 00:56'!
listChanged
	self refresh.
	self changed: #list.
	self nextChanged.
	browser nodeChanged.! !

!OBColumn methodsFor: 'drag and drop' stamp: 'avi 2/20/2004 14:36'!
dragTransferTypeForMorph: listMorph
	^ self dragTransferType! !

!OBColumn methodsFor: 'nodes' stamp: 'cwp 2/11/2004 00:11'!
nextMetaNode
	^ self filter childFor: self selectedNode.! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 2/11/2004 22:18'!
nextChanged
	selection = 0 ifFalse: [self next 
								metaNode: self nextMetaNode 
								parent: self selectedNode]
! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/11/2004 23:22'!
isEmpty
	^ parent isNil! !

!OBColumn methodsFor: 'initializing' stamp: 'cwp 2/9/2004 21:29'!
setBrowser: aBrowser metaNode: aMetaNode node: aNode
	browser _ aBrowser.
	filter _ aMetaNode filter monitor: self.
	parent _ aNode.
	self refresh! !

!OBColumn methodsFor: 'drag and drop' stamp: 'cwp 2/25/2004 21:26'!
wantsDroppedMorph: transferMorph event: evt inMorph: listMorph
	| node |
	(transferMorph isKindOf: TransferMorph) ifFalse: [^ false].
	transferMorph dragTransferType == self dragTransferType ifFalse: [^ false].
	node _ self nodeForDroppedMorph: transferMorph event: evt inMorph: listMorph.
	^ node notNil and: [node wantsDroppedNode: transferMorph passenger]! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 2/5/2004 20:13'!
menu: aMenu
	self actionsForParentNode, self actionsForSelectedNode
		do: [:action | 
			action monitor: self.
			action addItemToMenu: aMenu].
	^ aMenu! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/7/2004 15:56'!
parent
	^ parent! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 1/24/2004 00:55'!
nodeDeleted
	"This gets called by OBNodeDelete if an action causes the currently selected to be deleted."

	self refresh.
	self selection: 0.
! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 1/24/2004 00:54'!
notification: aNotification
	aNotification notify: self.! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 1/24/2004 01:03'!
list
	^ children 
		ifNil: [#()]
		ifNotNil: [children collect: [:ea | ea name]]! !

!OBColumn methodsFor: 'nodes' stamp: 'cwp 2/11/2004 21:29'!
selectAncestorOf: aNode
	| ancestor |
	ancestor _ self filter selectAncestorOf: aNode withParent: parent.
	ancestor ifNotNil: [self refresh; select: ancestor; selected].
	^ ancestor! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/12/2004 20:50'!
next
	^ self basicNext
		ifNil: [(self hasSelection and: [self shouldBeLast not])
				ifTrue: [self createNext]]
	! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 2/25/2004 20:39'!
listMorph
	^ (PluggableListMorph
		on: self
		list: #list
		selected: #selection
		changeSelected: #selection:
		menu: #menu:
		keystroke: #keystroke:from:)
			dragEnabled: self dragEnabled;
			dropEnabled: self dropEnabled;
			borderWidth: 0;
			autoDeselect: false;
			yourself! !

!OBColumn methodsFor: 'drag and drop' stamp: 'avi 2/20/2004 14:35'!
dragPassengerFor: item inMorph: listMorph
	^ self nodeForItem: item inMorph: listMorph! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/12/2004 19:53'!
metaNode: aMetaNode parent: aNode
	self filter: aMetaNode filter.
	self parent: aNode.
	self clearNext.! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/12/2004 20:49'!
basicNext
	^ browser columnAfter: self
		! !

!OBColumn methodsFor: 'actions' stamp: 'cwp 2/9/2004 20:45'!
actionsForParentNode
	^ self filter children gather: [:child | child actionsForParent: parent].	! !

!OBColumn methodsFor: 'actions' stamp: 'cwp 2/9/2004 20:45'!
actionsForSelectedNode
	| node meta |
	node _ children at: self selection ifAbsent: [^ #()].
	meta _ self filter childFor: node.
	^ meta actionsForNode: node	! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/9/2004 20:58'!
filter
	^ filter! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 2/11/2004 23:36'!
selected
	self next ifNotNilDo: [:column | column 
									metaNode: self nextMetaNode 
									parent: self selectedNode].
	browser selected: self! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/11/2004 22:13'!
parent: aNode
	parent _ aNode.
	self refresh.
	selection _ 0.
	self listChanged.! !

!OBColumn methodsFor: 'initializing' stamp: 'cwp 2/12/2004 19:40'!
setBrowser: aBrowser
	browser _ aBrowser.
	children _ #().
	selection _ 0.! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 1/7/2004 08:39'!
keystroke: aChar from: aMorph! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 2/9/2004 21:06'!
columnWithHeader
	| col bh |
	col _ BorderedMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		clipSubmorphs: true;
		color: Color transparent;
		cellInset: 0;
		borderWidth: 0;
		layoutPolicy: ProportionalLayout new.
	
	bh _ self buttonHeight negated.
	col
		addMorph: self listMorph
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@0 corner: 0@bh)).
	col
		addMorph: self filter buttonMorph
		fullFrame: (LayoutFrame fractions: (0@1 corner: 1@1) offsets: (0@bh corner: 0@0)).
		

	^ col! !

!OBColumn methodsFor: 'drag and drop' stamp: 'avi 2/20/2004 13:45'!
dragEnabled
	^ true! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 2/12/2004 20:50'!
clearNext
	self basicNext ifNotNilDo: [:next | next clear].! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 12/14/2003 21:18'!
browser: aBrowser
	browser _ aBrowser! !

!OBColumn class methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:05'!
inBrowser: aBrowser metaNode: aMetaNode node: aNode
	^ self new
			setBrowser: aBrowser
			metaNode: aMetaNode
			node: aNode! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 2/12/2004 20:17'!
clear
	self clearNext.
	filter _ nil.
	parent _ nil.
	children _ #().
	selection _ 0.
	self changed: #list.
	self changed: #selection.
	self changed: #filter.! !

!OBColumn methodsFor: 'nodes' stamp: 'cwp 2/9/2004 22:49'!
refresh
	children _ self filter nodesForParent: parent! !

!OBColumn methodsFor: 'drag and drop' stamp: 'cwp 2/25/2004 22:25'!
acceptDroppingMorph: transferMorph event: evt inMorph: listMorph
	^ [(self nodeForDroppedMorph: transferMorph event: evt inMorph: listMorph)
		acceptDroppedNode: transferMorph passenger]
			on: OBNotification
			do: [:aNotification |
				self notification: aNotification.
				aNotification resume]
! !

!OBColumn methodsFor: 'drag and drop' stamp: 'cwp 2/25/2004 22:23'!
nodeForDroppedMorph: transferMorph event: evt inMorph: pluggableListMorph
	| index item |
	index _ pluggableListMorph rowAtLocation: evt position.
	item _ pluggableListMorph listMorph item: index.
	^ self nodeForItem: item inMorph: pluggableListMorph! !

!OBColumn methodsFor: 'nodes' stamp: 'cwp 1/31/2004 10:23'!
select: aNode
	self selection: (children indexOf: aNode)! !

!OBColumn methodsFor: 'nodes' stamp: 'cwp 2/2/2004 21:54'!
selectedNode
	^ children at: self selection ifAbsent: [].! !

!OBColumn methodsFor: 'drag and drop' stamp: 'cwp 2/25/2004 22:18'!
nodeForItem: item inMorph: pluggableListMorph
	^ children 
		detect: [:child | child name = item contents]
		ifNone: [item contents]! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 2/11/2004 21:15'!
clicked
	(self selection = 0)
		ifTrue: [self deselected]
		ifFalse: [self selected]! !

!OBColumn methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:18'!
wantsButton
	^ self filter notNil and: [self filter wantsButton]! !

!OBColumn methodsFor: 'printing' stamp: 'cwp 2/11/2004 23:29'!
descriptor
	self isEmpty ifTrue: [^ 'empty'].
	selection = 0 ifFalse: [^ self selectedNode name].
	^ self metaNode nodeClass name! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/9/2004 20:59'!
metaNode
	^ self filter metaNode! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 2/12/2004 18:11'!
paneWithHeader
	^ OBPane forColumn: self withFilter: self filter! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 1/30/2004 00:38'!
accept: aText notifying: aController
	self selectedNode accept: aText notifying: aController.! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 2/25/2004 20:38'!
selection: anInteger
	selection _ anInteger.
	self clicked.
	self changed: #selection.
	browser nodeChanged.! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 2/12/2004 19:53'!
deselected
	browser deselected: self.
	self clearNext.! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 2/12/2004 18:10'!
simplePane
	^ OBPane forColumn: self! !

!OBColumn methodsFor: 'drag and drop' stamp: 'avi 2/20/2004 14:30'!
dropEnabled
	^ true! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 2/2/2004 22:02'!
nodeCreated: aNode
	browser jumpTo: aNode! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 12/14/2003 22:15'!
buttonHeight
	^ 20! !

!OBColumn class methodsFor: 'as yet unclassified' stamp: 'cwp 2/11/2004 23:25'!
inBrowser: aBrowser
	^ self new setBrowser: aBrowser! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 2/12/2004 19:17'!
morph
	^ self isEmpty 
		ifTrue: [self simplePane]
		ifFalse: [self filter wantsButton
							ifTrue: [self paneWithHeader]
							ifFalse: [self simplePane]]! !

!OBColumn methodsFor: 'drag and drop' stamp: 'avi 2/20/2004 14:37'!
dragTransferType
	^ #OmniBrowser! !

Object subclass: #OBMetaEdge
	instanceVariableNames: 'label selector metaNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBMetaEdge methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 22:36'!
setLabel: aString selector: aSelector metaNode: aMetaNode
	label _ aString.
	selector _ aSelector.
	metaNode _ aMetaNode! !

!OBMetaEdge methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 22:46'!
nodesForParent: aNode
	^ selector isUnary
		ifTrue: [aNode perform: selector]
		ifFalse: [Array with: (metaNode nodeClass perform: selector with: aNode)]! !

!OBMetaEdge class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 22:35'!
label: aString selector: aSelector metaNode: aMetaNode
	^ self new setLabel: aString selector: aSelector metaNode: aMetaNode! !

!OBMetaEdge methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 22:40'!
metaNode
	^ metaNode! !

!OBMetaEdge methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 22:40'!
selector
	^ selector! !

!OBMetaEdge methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 22:40'!
label
	^ label! !

!OBMetaEdge class methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 22:32'!
selector: aSelector metaNode: aMetaNode
	^ self new setLabel: aSelector asString selector: aSelector metaNode: aMetaNode! !

Object subclass: #OBFilter
	instanceVariableNames: 'metaNode monitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBFilter class methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 20:54'!
forMetaNode: aMetaNode
	^ self new setMetaNode: aMetaNode! !

OBFilter subclass: #OBModalFilter
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Utilities'!

!OBModalFilter methodsFor: 'morphs' stamp: 'cwp 2/25/2004 00:22'!
buttonMorph
	^ OBRadioButtonBar
		on: self
		list: #list
		selected: #selection
		changeSelected: #selection:! !

!OBModalFilter methodsFor: 'callbacks' stamp: 'cwp 2/9/2004 21:10'!
selection
	^ selection ifNil: [selection _ 1]! !

!OBModalFilter methodsFor: 'public' stamp: 'cwp 2/9/2004 21:16'!
nodesForParent: aNode
	^ (metaNode ownsNode: aNode)
		ifTrue: [self selectedEdge nodesForParent: aNode]
		ifFalse: [#()]! !

!OBModalFilter methodsFor: 'callbacks' stamp: 'cwp 2/25/2004 00:28'!
list
	^ metaNode edges collect: [:edge | edge label]! !

!OBModalFilter methodsFor: 'public' stamp: 'cwp 2/9/2004 22:23'!
selectAncestorOf: aNode withParent: parentNode
	| ancestor |
	1 	to: metaNode edges size 
	  	do: [:i | selection _ i.
			ancestor _ (self nodesForParent: parentNode)
				detect: [:child | child isAncestorOf: aNode] 
				ifNone: [nil].
			ancestor ifNotNil: [^ ancestor]].
	^ nil! !

!OBModalFilter methodsFor: 'queries' stamp: 'cwp 2/9/2004 21:08'!
wantsButton
	^ true! !

!OBModalFilter methodsFor: 'selection' stamp: 'cwp 2/9/2004 21:11'!
selectedEdge
	^ metaNode edges at: self selection ! !

!OBModalFilter methodsFor: 'callbacks' stamp: 'cwp 2/25/2004 00:33'!
selection: anInteger
	selection _ anInteger.
	self changed: #selection.
	monitor listChanged.
! !

!OBModalFilter methodsFor: 'selection' stamp: 'cwp 2/9/2004 21:11'!
incrementSelection
	selection _ selection + 1.
	(selection > metaNode edges size) ifTrue: [selection _ 1].! !

!OBFilter methodsFor: 'queries' stamp: 'cwp 2/9/2004 21:06'!
wantsButton
	^ false! !

!OBFilter methodsFor: 'initalizing' stamp: 'cwp 2/9/2004 20:54'!
setMetaNode: aMetaNode
	metaNode _ aMetaNode! !

!OBFilter methodsFor: 'accessing' stamp: 'cwp 2/9/2004 20:56'!
monitor: aMonitor
	monitor _ aMonitor! !

!OBFilter methodsFor: 'public' stamp: 'cwp 2/9/2004 20:52'!
nodesForParent: aNode
	^ metaNode nodesForParent: aNode! !

!OBFilter methodsFor: 'public' stamp: 'cwp 2/9/2004 20:51'!
childFor: aNode
	^ metaNode childFor: aNode! !

!OBFilter methodsFor: 'public' stamp: 'cwp 2/9/2004 20:50'!
children
	^ metaNode children! !

!OBFilter methodsFor: 'accessing' stamp: 'cwp 2/11/2004 23:48'!
metaNode
	^ metaNode! !

!OBFilter methodsFor: 'public' stamp: 'cwp 2/9/2004 22:21'!
selectAncestorOf: aNode withParent: parentNode
	^ (metaNode nodesForParent: parentNode)
		detect: [:child | child isAncestorOf: aNode] 
		ifNone: [nil]! !

Object subclass: #OBMetaGraphBuilder
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'OmniBrowser-Utilities'!

!OBMetaGraphBuilder class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 19:31'!
default
	^ Instance! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 2/20/2004 17:20'!
chaseImplementorsBrowser
	| root messages related |
	root _ OBMetaNode for: OBMethodNode.
	messages _ OBMetaNode for: OBSelectorNode.
	related _ OBMetaNode for: OBNakedMethodNode.
	
	root 
		childAt: #selectorAndMessages labeled: 'messages' put: messages;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	messages
		childAt: #implementors put: related;
		childAt: #senders put: related;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	related
		childAt: #messages put: messages;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
		
	^ root! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 2/9/2004 23:07'!
installGraphs
	OBBrowser 
	
		"Code browsers"
		metaGraphAt: #System put: self systemBrowser;
		metaGraphAt: #Image put: self imageBrowser;
		metaGraphAt: #Package put: self packageBrowser;
		metaGraphAt: #Implementors put: self implementorsBrowser;
		metaGraphAt: #Senders put: self sendersBrowser;

		"Experimental chasing browsers"
		metaGraphAt: #ChaseImplementors put: self chaseImplementorsBrowser;
		metaGraphAt: #ChaseSenders put: self chaseSendersBrowser;

		"FileSystem browsers"
		metaGraphAt: #FileSystem put: self fileSystemBrowser
	! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 18:28'!
imageBrowser
	^ (OBMetaNode for: OBSystemNode)
		childAt: #categories put: self catClassCatMethod! !

!OBMetaGraphBuilder methodsFor: 'private' stamp: 'cwp 2/25/2004 01:17'!
catClassCatMethod
	| classCategory class methodCategory method metaclass comment |
	classCategory _ OBMetaNode for: OBClassCategoryNode.
	class _ OBMetaNode for: OBClassNode.
	comment _ OBMetaNode for: OBClassCommentNode.
	metaclass _ OBMetaNode for: OBMetaclassNode.
	methodCategory _ OBMetaNode for: OBMethodCategoryNode.
	method _ OBMetaNode for: OBMethodNode.

	classCategory 
		childAt: #classes labeled: 'instance' put: class;
		childAt: #comments labeled: '?' put: comment;
		childAt: #metaclasses labeled: 'class' put: metaclass;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	class 
		childAt: #categories put: methodCategory;
		addActor: OBNodeActor new.
	metaclass
		childAt: #categories put: methodCategory.
	methodCategory 
		childAt: #methods put: method;
		addActor: OBNodeActor new.
	method 
		addActor: OBNodeActor new.
	
	^ classCategory! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 2/9/2004 22:58'!
sendersBrowser
	| root senders |
	root _ OBMetaNode for: OBSelectorNode.
	senders _ OBMetaNode for: OBNakedMethodNode.
	
	root
		childAt: #senders put: senders;
		addActor: OBNodeActor new.
	senders
		addActor: OBNodeActor new.
		
	^ root! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 22:11'!
metaGraphBrowser
	| dict assoc metaNode |
	dict _ OBMetaNode on: OBDictionaryNode.
	assoc _ OBMetaNode on: OBAssociationNode.
	metaNode _ OBMetaNode on: OBMetaNodeNode.
	
	dict childAt: #associations put: assoc.
	assoc childAt: #fromAssociation: put: metaNode.
	metaNode childAt: #children put: metaNode.

	^ dict ! !

!OBMetaGraphBuilder class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 19:33'!
initialize
	Instance _ self new.
	Instance installGraphs! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 1/24/2004 00:34'!
fileSystemBrowser
	| directory file |
	directory _ OBMetaNode for: OBDirectoryNode.
	file _ OBMetaNode for: OBFileNode.
	file 
		addActor: OBNodeActor new;
		addActor: OBFileRegistryActor new.
	directory 
		childAt: #directories put: directory;
		childAt: #files put: file.
	^ directory! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 18:28'!
systemBrowser
	^ (OBMetaNode for: OBSystemNode)
		childAt: #packages put: self packageBrowser! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 18:23'!
packageBrowser
	^ (OBMetaNode for: OBPackageNode)
		childAt: #categories put: self catClassCatMethod
	! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 2/9/2004 22:57'!
implementorsBrowser
	| root implementors |
	root _ OBMetaNode for: OBSelectorNode.
	implementors _ OBMetaNode for: OBNakedMethodNode.
	
	root
		childAt: #implementors put: implementors;
		addActor: OBNodeActor new.
	implementors
		addActor: OBNodeActor new.
		
	^ root! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 2/20/2004 17:20'!
chaseSendersBrowser
	| root messages related |
	root _ OBMetaNode for: OBMethodNode.
	messages _ OBMetaNode for: OBSelectorNode.
	related _ OBMetaNode for: OBNakedMethodNode.
	
	root 
		childAt: #selectorAndMessages labeled: 'messages' put: messages;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	messages
		childAt: #senders put: related;
		childAt: #implementors put: related;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	related
		childAt: #messages put: messages;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
		
	^ root! !

Object subclass: #OBActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBActor methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 20:12'!
actionsForParent: aNode
	^#()! !

!OBActor methodsFor: 'as yet unclassified' stamp: 'cwp 2/4/2004 15:25'!
actionsForNode: aNode
	^#()! !

!OBActor methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 20:19'!
attachToMetaNode: aMetaNode
	! !

OBActor subclass: #OBFileRegistryActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Actors'!

!OBFileRegistryActor methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 01:05'!
update: aParameter
	(aParameter == #fileListChanged) ifTrue: [self updateFileList].
	super update: aParameter! !

!OBFileRegistryActor methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 01:11'!
actionsForNode: aFileNode
	| services actions |
	services _ FileList itemsForFile: aFileNode path.
	services do: [:svc | svc addDependent: self].
	actions _ services collect: [:s | OBAction
							label: s label
							receiver: s
							selector: s requestSelector
							arguments: (Array with: aFileNode path)].
	^ actions! !

!OBFileRegistryActor methodsFor: 'as yet unclassified' stamp: 'cwp 2/25/2004 22:42'!
updateFileList
	OBListChanged signal! !

OBActor subclass: #OBNodeActor
	instanceVariableNames: 'nodeClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Actors'!

!OBNodeActor methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:24'!
actionsForNode: aNode
	^ aNode actions! !

!OBNodeActor methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 20:17'!
actionsForParent: aNode
	^ nodeClass actionsForParent: aNode! !

!OBNodeActor methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 20:19'!
attachToMetaNode: aMetaNode
	nodeClass _ aMetaNode nodeClass! !

Object subclass: #OBFakeClassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Fakes'!

Object subclass: #OBProtocolMock
	instanceVariableNames: 'messages exceptions isRecording'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBProtocolMock methodsFor: 'examining' stamp: 'cwp 2/13/2004 00:51'!
expect: aBlock
	isRecording _ true.
	messages _ OrderedCollection new.
	self do: aBlock.
	isRecording _ false.! !

!OBProtocolMock methodsFor: 'asserting' stamp: 'cwp 2/13/2004 01:30'!
deny: aBoolean
	self assert: aBoolean not! !

!OBProtocolMock methodsFor: 'asserting' stamp: 'cwp 2/13/2004 01:08'!
fail: aString
	^ TestResult failure sunitSignalWith: aString! !

!OBProtocolMock methodsFor: 'examining' stamp: 'cwp 2/13/2004 01:41'!
examine: aBlock
	[self do: aBlock]
		on: Exception
		do: [:exception | self handleException: exception].

	self assert: messages isEmpty
		message: 'Expected message not sent'.
	self deny: (exceptions notNil and: [exceptions notEmpty])
		message: 'Expected exception not raised'! !

!OBProtocolMock methodsFor: 'examining' stamp: 'cwp 2/13/2004 02:25'!
handleException: exception
	| expectation |
	self deny: (exceptions isNil or: [exceptions isEmpty])
		message: 'Unexpected ', exception printString.
	expectation _ exceptions removeFirst.
	self assert: exception class = expectation first 
		message: 'Unexpected exception'.
	exception isResumable ifTrue: [exception resume: expectation second]! !

!OBProtocolMock methodsFor: 'asserting' stamp: 'cwp 2/13/2004 01:29'!
deny: aBoolean message: aString
	self assert: aBoolean not message: aString! !

!OBProtocolMock methodsFor: 'asserting' stamp: 'cwp 2/13/2004 01:29'!
assert: aBoolean
	self assert: aBoolean message: 'Assertion failed'! !

!OBProtocolMock methodsFor: 'recording' stamp: 'cwp 2/13/2004 01:40'!
message: aMessage
	| expected |
	isRecording ifTrue: [messages add: aMessage. ^ self].
	
	self 
		deny: messages isEmpty 
		message: 'No more messages expected'.
	expected _ messages removeFirst.
	self assert: (expected sends: aMessage selector)
		message: 'Unexpected message'.
	self assert: expected arguments = aMessage arguments
		message: 'Incorrect arguments'.! !

!OBProtocolMock methodsFor: 'examining' stamp: 'cwp 2/13/2004 00:51'!
do: aBlock
	^ aBlock value: (OBMessageRecorder forMock: self)! !

!OBProtocolMock methodsFor: 'asserting' stamp: 'cwp 2/13/2004 01:28'!
assert: aBoolean message: aString
	aBoolean ifFalse: [self fail: aString]! !

!OBProtocolMock methodsFor: 'recording' stamp: 'cwp 2/13/2004 00:41'!
resume: aNotificationClass with: aValue
	exceptions ifNil: [exceptions _ OrderedCollection new].
	exceptions add: (Array with: aNotificationClass with: aValue)! !

!LazyListMorph methodsFor: '*omnibrowser' stamp: 'cwp 2/25/2004 21:17'!
rectForRow: index
	"return a rectangle containing the row at index"
	
	| top |
	top _ self top + (index - 1 * font height).
	^ (self left @ top) extent: self width @ font height
! !

TestResource subclass: #OBBrowserResource
	instanceVariableNames: 'model morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBBrowserResource methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2004 21:19'!
morph
	^ morph! !

OBBrowserResource subclass: #OBImageBrowserResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBImageBrowserResource methodsFor: 'running' stamp: 'cwp 2/16/2004 22:01'!
metaGraph
	^ OBMetaGraphBuilder default imageBrowser! !

!OBImageBrowserResource methodsFor: 'running' stamp: 'cwp 2/16/2004 22:01'!
node
	^ OBSystemNode on: OBImageContext new! !

!OBBrowserResource methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2004 21:19'!
model
	^ model! !

OBBrowserResource subclass: #OBSystemBrowserResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBSystemBrowserResource methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2004 22:03'!
node
	^ OBSystemNode on: OBImageContext new! !

!OBSystemBrowserResource methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2004 22:03'!
metaGraph
	^ OBMetaGraphBuilder default systemBrowser! !

OBBrowserResource subclass: #OBPackageBrowserResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBPackageBrowserResource methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2004 22:06'!
metaGraph
	^ OBMetaGraphBuilder default packageBrowser ! !

!OBPackageBrowserResource methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2004 22:06'!
node
	^ OBPackageNode on: OBFakePackage default! !

!OBBrowserResource methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2004 22:01'!
setUp
	model _ OBBrowser metaNode: self metaGraph node: self node.
	morph _ model window.! !

TestResource subclass: #OBDirectoryResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:15'!
tearDown
	self dataDir recursiveDelete! !

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2003 22:44'!
dataDirName
	^ 'obtest'! !

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2003 22:47'!
dataDir
	^ FileDirectory default directoryNamed: self dataDirName! !

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:15'!
setUp
	| dir |
	dir _ self dataDir.
	dir assureExistence.
	#(alpha beta gamma) do: [:filename | | file | file _ dir forceNewFileNamed: filename.
							  file nextPutAll: filename.
							  file close].
	dir createDirectory: 'delta'.
	(dir directoryNamed: 'delta') createDirectory: 'epsilon'.! !

TestCase subclass: #OBProtocolMockTest
	instanceVariableNames: 'mock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBProtocolMockTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:18'!
testMissingFailure
	mock expect: [:stub | stub foo; bar].
	self shouldFail: [mock examine: [:stub | stub foo]]! !

!OBProtocolMockTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:18'!
testSuccess
	mock expect: [:stub | stub foo; foo: #bar].
	mock examine: [:stub | stub foo; foo: #bar]
				
					! !

!OBProtocolMockTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:47'!
testTooManyExceptionsFailure
	mock 
		resume: Notification with: true;
		expect: [:stub | stub truth: true].
	self shouldFail: [mock examine: [:stub | stub truth: Notification signal. Notification signal]]! !

!OBProtocolMockTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:17'!
testExtraFailure
	mock expect: [:stub | stub foo].
	self shouldFail: [mock examine: [:stub | stub foo; bar]]! !

!OBProtocolMockTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:44'!
testNoExceptionFailure
	mock 
		resume: Notification with: true;
		expect: [:stub | stub truth: true].
	self shouldFail: [mock examine: [:stub | stub truth: true]] ! !

!OBProtocolMockTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:17'!
shouldFail: aBlock
	self should: aBlock raise: TestResult failure
				
					! !

!OBProtocolMockTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:20'!
testResume
	mock 
		resume: Notification with: true;
		expect: [:stub | stub truth: true];
		examine: [:stub | stub truth: Notification signal]! !

!OBProtocolMockTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:15'!
setUp
	mock _ OBProtocolMock new.! !

!OBProtocolMockTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:43'!
testWrongExceptionFailure
	mock 
		resume: Notification with: true;
		expect: [:stub | stub truth: true].
	self shouldFail: [mock examine: [:stub | stub truth: Error signal]] ! !

!OBProtocolMockTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:17'!
testArgFailure
	mock expect: [:stub | stub foo: #bar].
	self shouldFail: [mock examine: [:stub | stub foo: #baz]]
					! !

!OBProtocolMockTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:18'!
testSelectorFailure
	mock expect: [:stub | stub foo].
	self shouldFail: [mock examine: [:stub | stub bar]]
	! !

TestCase subclass: #OBContextTest
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBContextTest methodsFor: 'queries' stamp: 'cwp 2/7/2004 14:52'!
fakeASelectors
	^ (context methodsForClass: #OBFakeClassA)
		collect: [:ref | ref methodSymbol]! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 12:49'!
testMethodsForClass
	self assert: (self fakeASelectors includesAllOf: self fakeACoreSelectors).
	self deny: (self fakeASelectors includesAnyOf: self fakeAExtensionSelectors).! !

!OBContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 11:45'!
fakeCategory
	^ 'OmniBrowser-Fakes'! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 13:25'!
testClassCategories
	self assert: (context categories includesAllOf: self internalCategories).
	self deny: (context categories includesAnyOf: self externalCategories)! !

!OBContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 11:55'!
createFakeD
	Object subclass: #OBFakeClassD
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'OmniBrowser-Fakes'! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 12:17'!
testMethodCategoryOf
	| ref |
	ref _ MethodReference new setStandardClass: OBFakeClassA methodSymbol: #one.
	self assert: (context methodCategoryOf: ref) = 'numbers'! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/8/2004 12:07'!
testMethodsInCategoryOfClass
	| refs selectors |
	refs _ context methodsInCategory: 'numbers' ofClass: #OBFakeClassA.
	selectors _ refs collect: [:ref | ref methodSymbol].
	self assert: (selectors includesAllOf: #(one two three five))! !

!OBContextTest methodsFor: 'queries' stamp: 'cwp 2/7/2004 14:42'!
testClasses
	self createFakeD.
	self assertClassExists: #OBFakeClassD.
	context renameClass: #OBFakeClassD toBe: #OBFakeClassE.
	self assertClassExists: #OBFakeClassE.
	self denyClassExists: #OBFakeClassD.
	context removeClass: #OBFakeClassE.
	self denyClassExists: #OBFakeClassE! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 12:53'!
testClassesInCategory
	self assert: ((context classesInCategory: self fakeCategory)
					 includesAllOf: self fakeClasses).
	! !

!OBContextTest methodsFor: 'asserting' stamp: 'cwp 2/7/2004 12:02'!
assertClassExists: aString
	self assert: (self classExists: aString)! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 13:39'!
testClassCategoryOperations
	context addCategory: 'OBContext-Added'.
	self assert: (context categories includes: 'OBContext-Added').
	context renameCategory: 'OBContext-Added' toBe: 'OBContext-Renamed'.
	self assert: (context categories includes: 'OBContext-Renamed').
	self deny: (context categories includes: 'OBContext-Added').
	context removeCategory: 'OBContext-Renamed'.
	self deny: (context categories includes: 'OBContext-Renamed')
! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/13/2004 00:03'!
testMethodCategories
	context addCategory: 'added' toClass: #OBFakeClassB.
	self assert: ((context categoriesForClass: #OBFakeClassB) includes: 'added').
	context renameCategory: 'added' inClass: #OBFakeClassB toBe: 'renamed'.
	self assert: ((context categoriesForClass: #OBFakeClassB) includes: 'renamed').
	self deny: ((context categoriesForClass: #OBFakeClassB) includes: 'added').
	context removeCategory: 'renamed' fromClass: #OBFakeClassB.
	self deny: ((context categoriesForClass: #OBFakeClassB) includes: 'renamed')! !

!OBContextTest methodsFor: 'asserting' stamp: 'cwp 2/7/2004 12:02'!
denyClassExists: aString
	self deny: (self classExists: aString)! !

!OBContextTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 12:36'!
isAbstract
	^ self name = 'OBContextTest'! !

OBContextTest subclass: #OBPackageContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBPackageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 12:46'!
fakeAExtensionSelectors
	^ #(foo)! !

!OBPackageContextTest methodsFor: 'running' stamp: 'cwp 2/7/2004 13:33'!
setUp
	context _ OBPackageContext named: 'OmniBrowserFakes'! !

!OBPackageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 12:43'!
fakeCategory
	^ 'Fakes'! !

!OBPackageContextTest methodsFor: 'queries' stamp: 'cwp 2/7/2004 12:37'!
classExists: aString
	^ Smalltalk hasClassNamed: aString! !

!OBPackageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 13:27'!
internalCategories
	^ #('Fakes')! !

!OBPackageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 12:46'!
fakeACoreSelectors
	^ #(one two three a b)! !

!OBPackageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 13:27'!
externalCategories
	^ #('Kernel')! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 12:30'!
testPackages
	| names |
	names _ context packages collect: [:p | p packageName].
	self assert: (names includes: 'OmniBrowser').! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/9/2004 20:11'!
testCategoryOf
	self assert: (context categoryOf: #OBFakeClassA) = self fakeCategory.
	self assert: (context categoryOf: #'OBFakeClassA class') = self fakeCategory.! !

!OBContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 14:41'!
fakeClasses
	^ #(OBFakeClassA OBFakeClassB OBFakeClassC)! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/9/2004 23:42'!
testMessagesSentByInClass
	| messages |
	messages _ context messagesSentBy: #five inClass: #OBFakeClassA.
	self assert: (messages asSet = #(two + three) asSet)
	! !

OBContextTest subclass: #OBImageContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBImageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 13:31'!
internalCategories
	^ #('OmniBrowser-Kernel' 'OmniBrowser-Nodes' 'OmniBrowser-Actors')! !

!OBImageContextTest methodsFor: 'running' stamp: 'cwp 2/7/2004 12:35'!
setUp
	context _ OBImageContext new! !

!OBImageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 13:29'!
externalCategories
	^ #()! !

!OBImageContextTest methodsFor: 'queries' stamp: 'cwp 2/7/2004 12:35'!
classExists: aString
	^ Smalltalk hasClassNamed: aString! !

!OBImageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 12:48'!
fakeACoreSelectors
	^ #(one two three a b foo)! !

!OBImageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 12:48'!
fakeAExtensionSelectors
	^ #()! !

TestCase subclass: #OBFileNodeTest
	instanceVariableNames: 'node notification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 22:06'!
testDelete
	| actions delete |
	actions _ node actions.
	delete _ actions detect: [:a | a label = 'delete'] ifNone: [self signalFailure: 'No delete action'].
	delete monitor: self.
	delete trigger.
	self deny: ((FileDirectory default) fileExists: self dataFile).
	self assert: notification class = OBNodeDeleted

	! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:41'!
testText
	self assert: (node text = 'alpha')! !

!OBFileNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:32'!
resources
	^ Array with: OBDirectoryResource! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2004 21:38'!
tearDown
	| file |
	file _ FileStream fileNamed: self dataFile.
	file
		reset;
		nextPutAll: 'alpha';
		truncate: (file position);
		close.! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:40'!
setUp
	node _ OBFileNode on: self dataFile.! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:15'!
dataFile
	^ OBDirectoryResource current dataDir fullNameFor: 'alpha'! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:15'!
notification: aNotification
	notification _ aNotification! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:41'!
testName
	self assert: node name = 'alpha'! !

TestCase subclass: #OBRadioButtonBarTest
	instanceVariableNames: 'bar selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 2/24/2004 19:15'!
testUpdateSelection
	self changed: #list.
	selection _ 2.
	self changed: #selection.
	self assertSelectionIs: 2.! !

!OBRadioButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 2/24/2004 19:31'!
selection: anInteger
	selection _ anInteger.
	self changed: #selection! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 2/24/2004 19:09'!
testUpdateList
	| labels |
	self changed: #list.
	labels _ bar submorphs collect: [:b | b label].
	self assert: labels size = self list size.
	self assert: (labels includesAllOf: self list)! !

!OBRadioButtonBarTest methodsFor: 'asserting' stamp: 'cwp 2/24/2004 19:35'!
assertSelectionIs: anInteger
	self assert: selection = anInteger.
	bar submorphs withIndexDo: [:button :index |
								index = anInteger
									ifTrue: [self assert: button isOn]
									ifFalse: [self deny: button isOn]]! !

!OBRadioButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 2/22/2004 17:42'!
list
	^ #('alpha' 'beta' 'gamma')! !

!OBRadioButtonBarTest methodsFor: 'simulating' stamp: 'cwp 2/24/2004 18:26'!
push: aString
	| button |
	button _ bar submorphs detect: [:b | b label = aString].
	button performAction! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 2/24/2004 19:35'!
testPushAlphaBeta
	self changed: #list.
	self push: 'alpha'.
	self assertSelectionIs: 1.
	self push: 'beta'.
	self assertSelectionIs: 2.! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 2/24/2004 19:29'!
testLayout
	| rects |
	bar bounds: (10@10 corner: 310@30).
	self changed: #list.
	
	"This is an ugly hack. I can't figure out how else to force a layout."
	bar openInWorld.
	rects _ bar submorphs collect: [:b | b bounds].
	bar delete.

	self assert: (rects at: 1) = (10@10 corner: 110@30).
	self assert: (rects at: 2) = (110@10 corner: 201@30).
	self assert: (rects at: 3) = (201@10 corner: 310@30).! !

!OBRadioButtonBarTest methodsFor: 'running' stamp: 'cwp 2/25/2004 00:43'!
setUp
	selection _ 0.
	bar _ OBRadioButtonBar
			on: self
			list: #list
			selected: #selection
			changeSelected: #selection:.
! !

!OBRadioButtonBarTest methodsFor: 'testing' stamp: 'cwp 2/22/2004 16:53'!
testList
	self assert: bar list = self list! !

!OBRadioButtonBarTest methodsFor: 'callbacks' stamp: 'cwp 2/22/2004 16:39'!
selection
	^ selection! !

TestCase subclass: #OBFileNodeEditTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:30'!
createFile
	| file |
	file _ FileStream newFileNamed: self dataFile.
	file
		nextPutAll: 'omega';
		close.
! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:27'!
dataFile
	^ OBDirectoryResource current dataDir fullNameFor: 'omega'! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/30/2004 00:39'!
testAcceptText
	| file |
	node text: 'foo'.
	file _ FileStream readOnlyFileNamed: self dataFile.
	self assert: file contents = 'foo'! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:40'!
setUp
	self createFile.
	node _ OBFileNode on: self dataFile.
	! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:28'!
tearDown
	FileDirectory deleteFilePath: self dataFile! !

TestCase subclass: #OBBrowserTest
	instanceVariableNames: 'model morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 12/17/2003 15:07'!
assertAListMatches: strings
	| listMorphs list |
	listMorphs _ self listMorphs.
	listMorphs 
		detect: [:m | list _ m getList. (list size = strings size) and: [list includesAllOf: strings]]
		ifNone: [self assert: false].! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/30/2004 01:20'!
assertCurrentItemIs: aString
	self assert: self currentItem = aString! !

OBBrowserTest subclass: #OBFakeBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:30'!
testSelectA
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:30'!
testSelectC
	self select: #c.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #().
	self assertTextIs: 'c'! !

!OBFakeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/25/2004 21:52'!
drop: aPassenger on: targetName
	| list transfer event |
	list _ self findListContaining: targetName.
	self assert: list notNil.
	transfer _ TransferMorph withPassenger: aPassenger.
	transfer dragTransferType: #OmniBrowser.
	event _ self mouseMoveEventIn: targetName.
	self assert: (list model wantsDroppedMorph: transfer event: event inMorph: list).
	^ list model acceptDroppingMorph: transfer event: event inMorph: list! !

!OBFakeBrowserTest methodsFor: 'running' stamp: 'cwp 12/17/2003 15:12'!
node
	^ OBFakeNode new! !

!OBFakeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/25/2004 19:23'!
drag: passangerName to: targetName
	| passanger |
	passanger _ self drag: passangerName.
	self drop: passanger on: targetName! !

!OBFakeBrowserTest methodsFor: 'running' stamp: 'cwp 12/17/2003 15:13'!
metaGraph
	^ OBFakeNode metaGraph! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 16:44'!
testInitialDisplay
	self assert: self listMorphs size = 1.
	self assertListAt: 1 contains: #(a b c).
	self assertTextIs: ''.
	! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:59'!
testAcceptText
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'.
	self setText: 'x'.
	self assertListAt: 1 contains: #(x b c).
	self assertListAt: 2 contains: #(xa xb xc).
	self assertTextIs: 'x'
! !

!OBFakeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/25/2004 19:28'!
drag: nodeName
	| item list |
	item _ StringMorph contents: nodeName asString.
	list _ self findListContaining: nodeName.
	^ list model dragPassengerFor: item inMorph: list! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:29'!
testDeselectA
	self select: #a.
	self deselect: #a.
	self assertListAt: 1 contains: #(a b c).
	self assert: self listMorphs size = 1.
	self assertTextIs: ''.! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/25/2004 21:58'!
testDragAndDrop
	| node |
	self select: #a.
	node _ self drag: #ab.
	self assert: (node isKindOf: OBFakeNode).
	self assert: node name = #ab.
	self drop: node on: #c.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(cb).
	self assertCurrentItemIs: #c.
	self assertTextIs: 'c'! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/8/2003 20:33'!
testPanes
	| scroller |
	self assert: (self morphsOfClass: PluggableListMorph) size = 1.
	self assert: (self morphsOfClass: PluggableTextMorph) size = 1.
	scroller _ self morphNamed: 'scroller'.
	self assert: scroller panes size = model minPanes.! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/7/2004 08:27'!
testAction
	self select: #a.
	self selectMenuItem:  'become z'.
	self assertListAt: 1 contains:  #(z b c)! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 11/23/2003 13:12'!
testCreateWindow
	self assert: (morph isKindOf: SystemWindow).
	self assert: (morph label = 'OmniBrowser').
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/23/2004 21:33'!
testDeleteB
	self select: #b.
	self selectMenuItem: 'delete'.
	self assertListAt: 1 contains: #(a c).
	self assert: self listMorphs size = 1.
	self assertTextIs: ''.! !

!OBFakeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/25/2004 21:41'!
mouseMoveEventIn: name
	| rect plm |
	plm _ self findListContaining: name.
	rect _ plm listMorph rectForRow: (plm getList indexOf: name).
	^ MouseMoveEvent new
		setType: #mouseEnter
		startPoint: rect center + (rect width @ 0)
		endPoint: rect center
		trail: #()
		buttons: 4
		hand: ActiveHand
		stamp: Time millisecondClockValue! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 12/17/2003 15:07'!
assertAListIncludes: anArrayOfStrings
	self listMorphs 
			detect: [:m | m getList includesAllOf: anArrayOfStrings]
			ifNone: [self assert: false].! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/31/2004 00:15'!
assertListAt: index contains: items
	| list |
	list _ (self listMorphs 
				at: index 
				ifAbsent: [self signalFailure: 'List ', index asString, ' does not exist']) getList.
	self assert: (list size = items size).
	self assert: (list includesAllOf: items).! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
morphsOfClass: aClass
	| found |
	found _ OrderedCollection new.
	morph allMorphsDo: [:m | (m isMemberOf: aClass) ifTrue: [found add: m]].
	^ found! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 1/23/2004 23:30'!
selectMenuItem: aString
	| item |
	item _ self menuItemNamed: aString.
	item ifNil: [self signalFailure: 'Menu item ''', aString, ''' does not exist.'].
	item doButtonAction! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:07'!
findListContaining: aString
	^ self listMorphs detect: [:m | m getList includes: aString] ifNone: []! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
morphNamed: aString
	^ morph 
		findDeepSubmorphThat: [:m | m knownName = aString]
		ifAbsent: [self signalFailure: aString, 'not found']! !

!OBBrowserTest methodsFor: 'running' stamp: 'cwp 2/12/2004 19:02'!
setUp
	model _ OBBrowser metaNode: self metaGraph node: self node.
	morph _ model window.! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
setText: aString
	| textMorph |
	textMorph _ self textMorph.
	textMorph 
		selectAll;
		replaceSelectionWith: aString asText;
		accept.
	! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/23/2004 22:35'!
assertMenuContains: aString
	| item |
	item _ self menuItemNamed: aString.
	self assert: item notNil! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/31/2004 13:31'!
assertListAt: index includes: items
	| list |
	list _ (self listMorphs 
				at: index 
				ifAbsent: [self signalFailure: 'List ', index asString, ' does not exist']) getList.
	self assert: (list includesAllOf: items).! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
textMorph
	^ (self morphsOfClass: PluggableTextMorph) last! !

OBBrowserTest subclass: #OBCodeBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:48'!
methodOne
	^ 'one
	^ 1'! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/12/2004 20:36'!
deselectFakeCategory
	self deselect: self fakeCategoryName! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 16:52'!
testJumpToNumbers
	self selectFakePackage.
	model jumpTo: (OBMethodCategoryNode 
					on: 'numbers' 
					inClass: #OBFakeClassA 
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: 'numbers'.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:37'!
testButtonRemoval
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self deselectFakeCategory.
	self assertNoButtonsVisible.! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 2/10/2004 00:27'!
fakeAClassTemplate
	^  'OBFakeClassA class
	instanceVariableNames: ''foo'''! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/7/2004 16:23'!
selectFakePackage
	! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 2/25/2004 01:31'!
clearFakeBComment
	OBFakeClassB organization classComment: ''! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:00'!
fakeClassDDefinition
 ^ 'Object subclass: #OBFakeClassD
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''OmniBrowser-Fakes'''! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 2/25/2004 01:28'!
fakeClassBComment
	^ 'A comment for OBFakeClassB'! !

OBCodeBrowserTest subclass: #OBPackageBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBPackageBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 13:58'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 contains: #('Fakes').
	self assertTextIs: ''.
	! !

!OBPackageBrowserTest methodsFor: 'constants' stamp: 'cwp 2/16/2004 22:05'!
fakeCategoryName
	^ 'Fakes'! !

!OBPackageBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2004 22:06'!
resources
	^ Array with: OBPackageBrowserResource! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/25/2004 01:47'!
testEditComment
	self selectFakeCategory.
	self select: 'OBFakeClassB'.
	self switchToComment.
	self setText: self fakeClassBComment.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertCurrentItemIs: #OBFakeClassB.
	self assert: OBFakeClassB comment = self fakeClassBComment.! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 2/25/2004 01:14'!
fakeAComment
	^ OBFakeClassA comment asString! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 2/16/2004 22:09'!
browserResource
	^ self class resources first current! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 2/16/2004 22:16'!
setUp
	model _ self browserResource model.
	morph _ self browserResource morph. 
	model jumpToRoot.	
! !

OBCodeBrowserTest subclass: #OBImageBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBImageBrowserTest class methodsFor: 'resources' stamp: 'cwp 2/16/2004 21:59'!
resources
	^ Array with: OBImageBrowserResource ! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 13:58'!
fakeCategoryName
	^ 'OmniBrowser-Fakes'! !

!OBImageBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 14:44'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 includes: #('OmniBrowser-Fakes').
	self assertTextIs: ''.
	! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:35'!
testSelectOne
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self select: 'one'.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three').
	self assertTextIs: ((MethodReference class: OBFakeClassA selector: #one) source)! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 1/31/2004 14:47'!
restoreMethodOne
	OBFakeClassA compile: self methodOne! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:35'!
testSelectTests
	self selectFakeCategory.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertTextIs: self classTemplate! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/12/2004 20:37'!
selectFakeCategory
	self select: self fakeCategoryName! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:38'!
fakeClassCDefinition
 ^ 'Object subclass: #OBFakeClassC
	instanceVariableNames: ''foo''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''OmniBrowser-Fakes'''! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:34'!
testEditClass
	self selectFakeCategory.
	self select: 'OBFakeClassC'.
	self setText: self fakeClassCDefinition.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertCurrentItemIs: #OBFakeClassC.
	self assert: OBFakeClassC instVarNames = #(foo)! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 2/9/2004 20:00'!
methodA
	^ 'a
	^ $A'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:34'!
testColumnClearing
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self select: 'one'.
	self switchToClassSide.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertAListIncludes: #('capitals').
	self denyAListIncludes: #('letters' 'numbers').
	self denyAListIncludes: #('one' 'two' 'three').
	self assertTextIs: self fakeAClassTemplate! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 16:52'!
testJumpToFakeA
	self selectFakePackage.
	model jumpTo: (OBClassNode 
					on: #OBFakeClassA 
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: 'OBFakeClassA'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:35'!
testSelectNumbers
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three').
	self assertTextIs: self methodTemplate! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:34'!
testEditClassMethod
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self switchToClassSide.
	self select: 'capitals'.
	self select: 'a'.
	self setText: self altMethodA.
	self assertAListMatches: #('a' 'b').
	self assertCurrentItemIs: 'a'.
	self assert: $B = OBFakeClassA a! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/16/2004 20:36'!
testSelectAllMethodCategory
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self select: '-- all --'.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three' 'five' 'a' 'b').
	self assertTextIs: self methodTemplate! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 13:59'!
fakeATemplate
	^ 'Object subclass: #OBFakeClassA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''OmniBrowser-Fakes'''! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 16:52'!
testJumpToFakes
	self selectFakePackage.
	model jumpTo: (OBClassCategoryNode 
					on: self fakeCategoryName 
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: self fakeCategoryName! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/25/2004 01:11'!
switchToComment
	self clickButtonLabeled: '?'! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 2/9/2004 20:04'!
restoreMethodA
	OBFakeClassA class compile: self methodA! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 2/9/2004 19:57'!
altMethodA
	^ 'a
	^ $B'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 16:52'!
testJumpToMethodOne
	self selectFakePackage.
	model jumpTo: (OBMethodNode 
					on: #one 
					inClass: #OBFakeClassA
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: 'one'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/30/2004 23:59'!
methodFour
	^ 'four
	^ 4'! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/25/2004 01:13'!
clickButtonLabeled: aString
	| button |
	button _ (self morphsOfClass: PluggableButtonMorph) 
				detect: [:m | m label = aString]
				ifNone: [self signalFailure: 'No button labeled ', aString].
	button performAction! !

!OBCodeBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2004 13:08'!
isAbstract
	^ self name = #OBCodeBrowserTest! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:34'!
testCreateMethodFromTemplate
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self setText: self methodFour.
	self assertAListMatches: #('one' 'two' 'three' 'four' 'five').
	self assertCurrentItemIs: 'four' 
! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 1/31/2004 14:41'!
restoreFakeClassC
	Compiler evaluate: 'Object subclass: #OBFakeClassC
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''OmniBrowser-Fakes'''! !

OBCodeBrowserTest subclass: #OBSystemBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBSystemBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/16/2004 22:04'!
resources
	^ Array with: OBSystemBrowserResource! !

!OBSystemBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:07'!
fakeCategoryName
	^ 'Fakes'! !

!OBSystemBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/7/2004 16:24'!
selectFakePackage
	self select: 'OmniBrowserFakes'! !

!OBSystemBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 14:43'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 includes: #('OmniBrowser').
	self assertTextIs: ''.
	! !

!OBSystemBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/12/2004 20:34'!
selectFakeCategory
	self selectSequence: #('OmniBrowser' 'Fakes')! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:34'!
testCreateClassFromClass
	self selectFakeCategory.
	self select: 'OBFakeClassC'.
	self setText: self fakeClassDDefinition.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC OBFakeClassD).
	self assertCurrentItemIs: #OBFakeClassD ! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/25/2004 01:12'!
testSelectFakeAComment
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self switchToComment.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self denyAListIncludes: #('letters' 'numbers').
	self assertTextIs: self fakeAComment.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:34'!
testDeselectFakeA
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self deselect: 'OBFakeClassA'.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self denyAListIncludes: #('letters' 'numbers').
	self assertTextIs: self classTemplate.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:34'!
testCreateClassFromTemplate
	self selectFakeCategory.
	self setText: self fakeClassDDefinition.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC OBFakeClassD).
	self assertCurrentItemIs: #OBFakeClassD ! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:34'!
testEditMethod
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self select: 'one'.
	self setText: self altMethodOne.
	self assertAListMatches: #('one' 'two' 'three' 'five').
	self assertCurrentItemIs: 'one'.
	self assert: 11 = OBFakeClassA new one! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:34'!
testCreateMethodFromMethod
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self select: 'one'.
	self setText: self methodFour.
	self assertAListMatches: #('one' 'two' 'three' 'four' 'five').
	self assertCurrentItemIs: 'four' 
! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/30/2004 23:44'!
methodTemplate
	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:34'!
testSelectFakeA
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertAListIncludes: #('letters' 'numbers').
	self assertTextIs: self fakeATemplate! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:47'!
altMethodOne
	^ 'one
	^ 11'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:01'!
classTemplate
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''OmniBrowser-Fakes'''! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/12/2004 20:35'!
testSelectFakeAClassSide
	self selectFakeCategory.
	self select: 'OBFakeClassA'.
	self switchToClassSide.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertAListIncludes: #('capitals').
	self assertTextIs: self fakeAClassTemplate! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/25/2004 01:10'!
switchToClassSide
	self clickButtonLabeled: 'class'! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 2/25/2004 01:28'!
tearDown
	super tearDown.
	(Smalltalk hasClassNamed: 'OBFakeClassD') 
		ifTrue: [Smalltalk removeClassNamed: 'OBFakeClassD'].
	OBFakeClassA removeSelector: #four.
	self restoreFakeClassC.
	self restoreMethodOne.
	self restoreMethodA.
	self clearFakeBComment! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 2/12/2004 19:23'!
denyAListIncludes: anArrayOfStrings
	self listMorphs 
			detect: [:m | m getList includesAllOf: anArrayOfStrings]
			ifNone: [^ self].
	self assert: false.! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
deselect: aString
	| listMorph |
	listMorph _ self findListContaining: aString.
	listMorph changeModelSelection: 0.! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
listMorphs
	^ self morphsOfClass: PluggableListMorph! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 1/31/2004 13:24'!
currentList
	^ self listMorphs reversed detect: [:list | list selection notNil]! !

OBBrowserTest subclass: #OBMetaGraphBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBMetaGraphBrowserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 19:50'!
node
	^ OBDictionaryNode on: OBBrowser metaGraphs! !

!OBMetaGraphBrowserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:22'!
testInitialDisplay
	self listMorphs size = 1.
	self assertAListIncludes: #(System Package Image FileSystem).
	self assertTextIs: ''.
	! !

!OBMetaGraphBrowserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:23'!
metaGraph
	^ OBMetaGraphBuilder default metaGraphBrowser! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 12/17/2003 15:07'!
assertTextIs: aString
	self assert: self textMorph text = aString.! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 2/12/2004 20:39'!
assertNoButtonsVisible
	self assert: (self morphsOfClass: PluggableButtonMorph) isEmpty.! !

!OBBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 15:10'!
isAbstract
	^ self name = 'OBBrowserTest'! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 1/31/2004 13:23'!
currentItem
	^ self currentList selection! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
select: aString
	| listMorph |
	listMorph _ self findListContaining: aString.
	self assert: listMorph notNil.
	listMorph changeModelSelection: (listMorph getList indexOf: aString).! !

OBBrowserTest subclass: #OBDirectoryBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBDirectoryBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 10:13'!
epsilonNode
	^ OBFileNode 
		on: ((OBDirectoryResource current dataDir directoryNamed: 'delta') fullNameFor: 'epsilon')! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 15:19'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 contains: #(alpha beta gamma delta).
	self assertTextIs: ''.
	! !

!OBDirectoryBrowserTest methodsFor: 'constants' stamp: 'cwp 12/17/2003 15:14'!
node
	^ OBDirectoryNode on: OBDirectoryResource current dataDir! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 10:13'!
testJumpToEpsilon
	| node |
	node _ self epsilonNode.
	model jumpTo: node.
	self assertListAt: 1 contains: #(alpha beta gamma delta).
	self assertListAt: 2 contains: #(epsilon).
	self assertCurrentItemIs: 'epsilon'.! !

!OBDirectoryBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 15:09'!
resources
	^ Array with: OBDirectoryResource! !

!OBDirectoryBrowserTest methodsFor: 'constants' stamp: 'cwp 12/18/2003 18:33'!
metaGraph
	^ OBMetaGraphBuilder default fileSystemBrowser! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 17:01'!
testSelectAlpha
	self select: 'alpha'.
	self assertListAt: 1 contains: #(alpha beta gamma delta).
	self assertTextIs: 'alpha'! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 1/23/2004 23:33'!
testMenuItems
	self select: 'alpha'.
	self assertMenuContains: 'delete'! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 1/26/2004 21:53'!
menuItemNamed: aString
	| lists current |
	lists _ self listMorphs.
	current _ lists reversed detect: [:list | list selection notNil].
	^ (current getMenu: true) itemWithWording: aString.
! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/12/2004 19:47'!
selectSequence: aCollection
	| list |
	aCollection withIndexDo: [:item :index | 
					list _ self listMorphs at: index.
					list changeModelSelection: (list getList indexOf: item)]! !

TestCase subclass: #OBFileRegistryActorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFileRegistryActorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:26'!
assertActions: actions include: required
	| labels |
	labels _ actions collect: [:act | act label].
	self assert: (required includesAllOf: labels)! !

!OBFileRegistryActorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:26'!
testTextFile
	| actor node actions |
	actor _ OBFileRegistryActor new.
	node _ OBFileNode on: (FileDirectory default fullNameFor: 'foo.txt').
	actions _ actor actionsForNode: node.
	self assertActions: actions include: #('add file to new zip' 'compress file').! !

TestCase subclass: #OBDirectoryNodeTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:39'!
testName
	self assert: node name = 'obtest'! !

!OBDirectoryNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:32'!
resources
	^ Array with: OBDirectoryResource! !

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 15:01'!
testDirectoryNodes
	| children |
	children _ node directories collect: [:n | n name].
	self assert: children = #(delta)
	! !

!OBDirectoryNodeTest methodsFor: 'running' stamp: 'cwp 12/15/2003 21:39'!
setUp
	node _ OBDirectoryNode on: self dataDir.! !

!OBDirectoryNodeTest methodsFor: 'data' stamp: 'cwp 11/28/2003 22:47'!
dataDir
	^ OBDirectoryResource current dataDir! !

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:39'!
testText
	self assert: (node text endsWith: '
----------
alpha - 5 bytes
beta - 4 bytes
delta - 0 bytes
gamma - 5 bytes
')
! !

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 14:49'!
testFileNodes
	| children |
	children _ node files.
	self assert: (children collect: [:n | n name]) = #(alpha beta gamma)
	! !

TestCase subclass: #OBDictionaryNodeTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBDictionaryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:15'!
setUp
	| dict |
	dict _ Dictionary new.
	dict
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	node _ OBDictionaryNode on: dict! !

!OBDictionaryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:16'!
testNames
	| list |
	list _ node associations collect: [:n | n name].
	self assert: (list includesAllOf: #(one two three))! !

TestCase subclass: #OBClassNodeActionTest
	instanceVariableNames: 'mock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBClassNodeActionTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 02:13'!
setUp
	mock _ OBProtocolMock new! !

!OBClassNodeActionTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 02:00'!
trigger: aString inContext: aContext
	| action actor node parent |
	actor _ self actor.
	node _ self nodeInContext: aContext.
	parent _ self parentInContext: aContext.
	action _ ((actor actionsForNode: node), (actor actionsForParent: parent))
		detect: [:a | a label = aString]
		ifNone: [self signalFailure: 'No action with label: ', aString].
	action monitor: self.
	action trigger! !

!OBClassNodeActionTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 02:03'!
nodeClass
	^ OBClassNode! !

!OBClassNodeActionTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 02:18'!
testRenameClass
	mock 
		resume: OBTextRequest with: 'OBFakeClassE';
		expect: [:context | context renameClass: #OBFakeClassA toBe: #OBFakeClassE];
		examine: [:context | self trigger: 'rename...' inContext: context]
				! !

!OBClassNodeActionTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 02:09'!
notification: aNotification! !

!OBClassNodeActionTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:55'!
actor
	^ OBNodeActor new attachToMetaNode: self! !

!OBClassNodeActionTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 02:13'!
testRemoveClass
	mock 
		expect: [:context | context removeClass: #OBFakeClassA];
		examine: [:context | self trigger: 'remove' inContext: context]
				! !

!OBClassNodeActionTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 02:02'!
parentInContext: aContext
	^ OBPackageNode on: aContext! !

!OBClassNodeActionTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 02:04'!
nodeInContext: aContext
	^ OBClassNode on: #OBFakeClassA inContext: aContext! !

TestCase subclass: #OBNodeTest
	instanceVariableNames: 'context notification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBNodeTest methodsFor: 'callbacks' stamp: 'cwp 2/2/2004 21:37'!
notification: aNotification
	notification _ aNotification! !

!OBNodeTest methodsFor: 'private' stamp: 'cwp 2/5/2004 21:26'!
actionWithLabel: aString
	^ self actionFrom: self node withLabel: aString! !

!OBNodeTest methodsFor: 'asserting' stamp: 'cwp 2/5/2004 23:35'!
assertNodeCreated
	self assert: (notification isKindOf: OBNodeSelected)! !

!OBNodeTest methodsFor: 'private' stamp: 'cwp 2/5/2004 20:30'!
actor
	^ OBNodeActor new attachToMetaNode: self! !

!OBNodeTest methodsFor: 'private' stamp: 'cwp 2/5/2004 20:29'!
parent
	^ OBPackageNode on: context! !

OBNodeTest subclass: #OBClassCategoryNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBClassCategoryNodeTest methodsFor: 'callbacks' stamp: 'cwp 2/5/2004 21:53'!
nodeClass
	^ OBClassCategoryNode ! !

!OBClassCategoryNodeTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 14:14'!
testCreateCategory
	| action |
	action _ self actionWithLabel: 'create category...'.
	[action trigger] on: OBTextRequest do: [:n | n resume: 'OBContext-Quux'].
	self assert: (context categories includes: 'OBContext-Quux').
	self assertNodeCreated.
	self assert: notification node name = 'OBContext-Quux'! !

!OBClassCategoryNodeTest methodsFor: 'running' stamp: 'cwp 2/7/2004 14:16'!
tearDown
	context 
		removeCategory: 'OBContext-Foo';
		removeCategory: 'OBContext-Bar';
		removeCategory: 'OBContext-Quux'! !

!OBClassCategoryNodeTest methodsFor: 'running' stamp: 'cwp 2/7/2004 14:22'!
setUp
	context _ OBPackageContext named: 'OmniBrowserFakes'.
	context 
		addCategory: 'OBContext-Foo';
		addCategory: 'OBContext-Bar'! !

!OBClassCategoryNodeTest methodsFor: 'private' stamp: 'cwp 2/7/2004 14:25'!
node
	^ OBClassCategoryNode on: 'OBContext-Foo' inContext: context! !

!OBClassCategoryNodeTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 14:14'!
testRemoveCategory
	| action |
	action _ self actionFrom: self removalNode withLabel: 'remove'.
	action trigger.
	self deny: (context categories includes: 'OBContext-Bar').
	! !

!OBClassCategoryNodeTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 14:26'!
testRenameCategory
	| action |
	action _ self actionWithLabel: 'rename...'.
	[action trigger]
		on: OBTextRequest
		do: [:n | n resume: 'OBContext-Quux'].
	self assert: (context categories includes: 'OBContext-Quux').
	self deny: (context categories includes: 'OBContext-Foo').
	! !

!OBClassCategoryNodeTest methodsFor: 'private' stamp: 'cwp 2/7/2004 14:25'!
removalNode
	^ OBClassCategoryNode on: 'OBContext-Bar' inContext: context! !

OBNodeTest subclass: #OBSelectorNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:37'!
setUp
	context _ OBImageContext new.! !

!OBSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 13:23'!
testSenders
	| node |
	node _ self nodeFor: #two.
	self assert: (node senders includes: (OBNakedMethodNode 
											on: #five 
											inClass: #OBFakeClassA
											inContext: context))
! !

!OBSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:37'!
nodeFor: aSelector
	^ OBSelectorNode on: aSelector inContext: context! !

!OBSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 13:20'!
testImplementors
	| node |
	node _ self nodeFor: #five.
	self assert: (node implementors includes: (OBNakedMethodNode
												on: #five
												inClass: #OBFakeClassA
												inContext: context))! !

OBNodeTest subclass: #OBMethodCategoryNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 10:35'!
parent
	^ OBClassNode on: self fakeClass inContext: context! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 00:03'!
testCreateCategory
	| action |
	action _ self actionWithLabel: 'create category...'.
	[action trigger] on: OBTextRequest do: [:n | n resume: 'quux'].
	self assert: ((context categoriesForClass: self fakeClass) includes: 'quux').
	self assertNodeCreated.
	self assert: notification node name = 'quux'! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:34'!
tearDown
	context 
		removeCategory: 'foo' fromClass: self fakeClass;
		removeCategory: 'quux' fromClass: self fakeClass;
		removeCategory: 'bar' fromClass: self fakeClass! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:13'!
fakeClass
	^ #OBFakeClassB! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 00:04'!
testRenameCategory
	| action |
	action _ self actionWithLabel: 'rename...'.
	[action trigger]
		on: OBTextRequest
		do: [:n | n resume: 'quux'].
	self assert: ((context categoriesForClass: self fakeClass) includes: 'quux').
	self deny: ((context categoriesForClass: self fakeClass) includes: 'foo').
	self assert: (notification isKindOf: OBListChanged)
	! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 11:31'!
setUp
	context _ OBImageContext new.
	context 
		addCategory: 'foo' toClass: self fakeClass;
		addCategory: 'bar' toClass: self fakeClass.! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 10:24'!
node
	^ OBMethodCategoryNode on: 'foo' inClass: self fakeClass inContext: context ! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 00:04'!
testRemoveCategory
	| action |
	action _ self actionFrom: self removalNode withLabel: 'remove'.
	action trigger.
	self deny: ((context categoriesForClass: self fakeClass) includes: 'bar').
	self assert: (notification isKindOf: OBNodeDeleted)
	! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 10:22'!
nodeClass
	^ OBMethodCategoryNode! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 11:29'!
removalNode
	^ OBMethodCategoryNode on: 'bar' inClass: self fakeClass inContext: context.! !

OBNodeTest subclass: #OBMethodNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 18:50'!
tearDown
	OBFakeClassA removeSelector: #four! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 19:00'!
node
	^ OBMethodNode
		on: #four
		inClass: #OBFakeClassA
		inContext: context! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:28'!
nodeInFakeA: aSelector 
	^ OBMethodNode
		on: aSelector
		inClass: #OBFakeClassA
		inContext: context! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 19:06'!
testRemoveMethod
	| action selectors |
	action _ self actionWithLabel: 'remove'.
	action trigger.
	selectors _ (context methodsForClass: #OBFakeClassA)
				collect: [:ref | ref methodSymbol].
	self deny: (selectors includes: #four)! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:29'!
nodeFive
	^ self nodeInFakeA: #five! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 14:30'!
testMessages
	self nodeFive messages do: [:node | 
								self assert: (node isKindOf: OBNode).
								self assert: (#(+ two three five) includes: node selector)] ! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 18:56'!
createFour
	OBFakeClassA compile: 'four ^ 4' classified: 'numbers'! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 19:01'!
nodeClass
	^ OBMethodNode! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 11:38'!
testImplementors
	self assert: (self node implementors includes: self node)! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 18:49'!
setUp
	self createFour.
	context _ OBImageContext new.! !

!OBNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 22:17'!
isAbstract
	^ self name = #OBNodeTest! !

!OBNodeTest methodsFor: 'private' stamp: 'cwp 2/5/2004 21:26'!
actionFrom: aNode withLabel: aString
	| action actor |
	actor _ self actor.
	action _ ((actor actionsForNode: aNode), (actor actionsForParent: self parent))
		detect: [:a | a label = aString]
		ifNone: [self signalFailure: 'No action with label: ', aString].
	action monitor: self.
	^ action! !

!BorderedSubpaneDividerMorph methodsFor: '*omnibrowser' stamp: 'cwp 2/8/2004 00:08'!
idealWidth
	^ 4! !

ProtoObject subclass: #OBMessageRecorder
	instanceVariableNames: 'mock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBMessageRecorder methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 00:40'!
doesNotUnderstand: aMessage
	mock message: aMessage! !

!OBMessageRecorder methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 00:24'!
obmrSetMock: aMockObject
	mock _ aMockObject! !

!OBMessageRecorder class methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 00:25'!
forMock: aMock
	^ self new obmrSetMock: aMock! !

!OBMessageRecorder methodsFor: 'as yet unclassified' stamp: 'cwp 2/13/2004 01:14'!
inspectorClass
	^ Inspector! !

!Morph methodsFor: '*omnibrowser' stamp: 'cwp 2/8/2004 00:37'!
idealWidth
	^ self allMorphs 
			inject: 0 
			into: [:widest :morph | 
					(morph isKindOf: StringMorph)
						ifTrue: [widest max: (morph measureContents x) + 5]
						ifFalse: [widest]]! !

MessageSend subclass: #OBAction
	instanceVariableNames: 'label monitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBAction methodsFor: 'evaluating' stamp: 'cwp 1/7/2004 18:22'!
perform: aSelector orSendTo: anObject
	^ self perform: aSelector! !

!OBAction methodsFor: 'accessing' stamp: 'cwp 1/7/2004 09:12'!
label: aString
	label _ aString! !

!OBAction class methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2004 09:20'!
label: aString receiver: anObject selector: aSelector arguments: anArray
	^ (self receiver: anObject selector: aSelector arguments: anArray) label: aString! !

!OBAction methodsFor: 'evaluating' stamp: 'cwp 2/2/2004 21:11'!
trigger
	[self value]
		on: OBNotification
		do: [:aNotification | 
			monitor notification: aNotification. 
			aNotification resume].! !

!OBAction methodsFor: 'morphic' stamp: 'cwp 1/7/2004 09:52'!
addItemToMenu: aMenu
	aMenu
		add: label
		target: self 
		selector: #trigger! !

!OBAction methodsFor: 'accessing' stamp: 'cwp 1/7/2004 09:59'!
monitor: anObject
	monitor _ anObject! !

!OBAction methodsFor: 'accessing' stamp: 'cwp 1/7/2004 09:11'!
label
	^ label! !

Slider subclass: #OBScrollBar
	instanceVariableNames: 'upButton downButton pagingArea scrollDelta pageDelta interval menuSelector timeOfMouseDown timeOfLastScroll nextPageDirection currentScrollDelay'
	classVariableNames: 'CachedImages UpArrow8Bit UpArrow'
	poolDictionaries: ''
	category: 'OmniBrowser-Morphs'!

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:06'!
extent: p
        p x > p y
                ifTrue: [super extent: (p max: 42@8)]
                ifFalse: [super extent: (p max: 8@42)]! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:07'!
totalSliderArea
	| upperBoundsButton |
	upperBoundsButton _ upButton.
	upButton bottom > upperBoundsButton bottom
		ifTrue: [upperBoundsButton _ upButton].
	^ bounds isWide
		ifTrue: [upperBoundsButton bounds topRight corner: downButton bounds bottomLeft]
		ifFalse: [upperBoundsButton bounds bottomLeft corner: downButton bounds topRight].
! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
alternativeScrollbarLook
	^Preferences alternativeScrollbarLook! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollDown
	self flag: #obsolete.
	downButton eventHandler: nil.
	downButton on: #mouseDown send: #scrollDownInit to: self.
	downButton on: #mouseUp send: #finishedScrolling to: self.
	^self scrollDownInit! !

!OBScrollBar methodsFor: 'scroll timing' stamp: 'cwp 11/23/2003 18:07'!
resetTimer
	timeOfMouseDown _ Time millisecondClockValue.
	timeOfLastScroll _ timeOfMouseDown - 1000 max: 0.
	nextPageDirection _ nil.
	currentScrollDelay _ nil! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
scrollDelta
	^ scrollDelta! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollUpInit
	upButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollUp.
	self startStepping.! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:07'!
sliderThickness
	^ self roundedScrollbarLook ifTrue:[15] ifFalse:[super sliderThickness]! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializePagingArea
	pagingArea := RectangleMorph newBounds: self totalSliderArea
								color: (Color r: 0.6 g: 0.6 b: 0.8).
	pagingArea borderWidth: 0.
	pagingArea on: #mouseDown send: #scrollPageInit: to: self.
	pagingArea on: #mouseUp send: #finishedScrolling to: self.
	self addMorph: pagingArea.
	self roundedScrollbarLook 
		ifTrue:[pagingArea color: (Color gray: 0.9)].! !

!OBScrollBar methodsFor: 'testing' stamp: 'cwp 11/23/2003 18:06'!
stepTime
	^ currentScrollDelay ifNil: [300]! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollBarAction
	^self valueOfProperty: #scrollBarAction! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializeDownButton
	downButton := RectangleMorph
		newBounds: (self innerBounds bottomRight - self buttonExtent extent: self buttonExtent)
		color: self thumbColor.
	downButton on: #mouseDown send: #scrollDownInit to: self.
	downButton on: #mouseUp send: #finishedScrolling to: self.
	downButton addMorphCentered: (ImageMorph new image: 
		(self 
			cachedImageAt: (bounds isWide ifTrue: ['right'] ifFalse: ['down']) 
			ifAbsentPut: [
				self upArrow8Bit
					rotateBy: (bounds isWide ifTrue: [#right] ifFalse: [#pi])
					centerAt: 0@0
			]
		)
	).
	self roundedScrollbarLook ifTrue:[
		downButton color: Color veryLightGray.
		downButton borderStyle: (BorderStyle complexRaised width: 3).
	] ifFalse:[
		downButton setBorderWidth: 1 borderColor: #raised.
	].
	self addMorph: downButton.
! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
setNextDirectionFromEvent: event

	nextPageDirection _ bounds isWide ifTrue: [
		event cursorPoint x >= slider center x
	]
	ifFalse: [
		event cursorPoint y >= slider center y
	]

! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollDownInit
	downButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollDown.
	self startStepping.! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializeEmbedded: aBool
	"aBool == true => inboard scrollbar
	aBool == false => flop-out scrollbar"
	self roundedScrollbarLook ifFalse:[^self].
	aBool ifTrue:[
		self borderStyle: (BorderStyle inset width: 2).
		self cornerStyle: #square.
	] ifFalse:[
		self borderStyle: (BorderStyle width: 1 color: Color black).
		self cornerStyle: #rounded.
	].
	self removeAllMorphs.
	self initializeSlider.! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
sliderShadowColor
	^ self roundedScrollbarLook
		ifTrue: [self sliderColor darker]
		ifFalse: [super sliderShadowColor]
! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollPageInit: evt
	self resetTimer.
	self setNextDirectionFromEvent: evt.
	self scrollBarAction: #doScrollByPage.
	self startStepping.! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
interval: d
	"Supply an optional floating fraction so slider can expand to indicate range"
	interval _ d min: 1.0.
	self expandSlider.
	self computeSlider.! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollUp: count
	self setValue: (value - (scrollDelta * count) - 0.000001 max: 0.0)! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:06'!
sliderExtent
	"The sliderExtent is now stored in the slider itself, not hardcoded as it is in the superclass."
	^slider extent! !

!OBScrollBar methodsFor: 'initialization' stamp: 'cwp 11/23/2003 18:07'!
initialize
	super initialize.
	scrollDelta _ 0.02.
	pageDelta _ 0.2.
	self roundedScrollbarLook ifTrue:[
		self borderStyle: ((BorderStyle complexFramed width: 2) "baseColor: Color gray")].! !

!OBScrollBar methodsFor: 'testing' stamp: 'cwp 11/23/2003 18:06'!
wantsSteps
	^self scrollBarAction notNil! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollUp
	self flag: #obsolete.
	upButton eventHandler: nil.
	upButton on: #mouseDown send: #scrollUpInit to: self.
	upButton on: #mouseUp send: #finishedScrolling to: self.
	^self scrollUpInit! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
doScrollDown
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value + scrollDelta + 0.000001 min: 1.0)! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
doScrollByPage
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 300 delay2: 100) ifFalse: [^ self].
	nextPageDirection
		ifTrue: [self setValue: (value + pageDelta min: 1.0)]
		ifFalse: [self setValue: (value - pageDelta max: 0.0)]
! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
finishedScrolling
	self stopStepping.
	self scrollBarAction: nil.
	self roundedScrollbarLook ifTrue:[
		upButton borderStyle: (BorderStyle complexRaised width: upButton borderWidth).
		downButton borderStyle: (BorderStyle complexRaised width: downButton borderWidth).
	] ifFalse:[
		downButton borderRaised.
		upButton borderRaised.
	].

! !

!OBScrollBar class methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2003 18:07'!
alwaysShowFlatScrollbarForAlternativeLook
	"Set this value to true, if you want to see the flat scrollbar look in flop-out mode as well as inboard.  Otherwise the flop-out scrollbar will be rounded and inboard will be flat."
	^ false! !

!OBScrollBar methodsFor: 'other events' stamp: 'cwp 11/23/2003 18:06'!
mouseDownInSlider: event
	interval = 1.0 ifTrue:
		["make the entire scrollable area visible if a full scrollbar is clicked on"
		self setValue: 0.
		self model hideOrShowScrollBar].
	super mouseDownInSlider: event! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializeSlider
	self roundedScrollbarLook ifTrue:[
		self 
			initializeUpButton;
			initializeDownButton;
			initializePagingArea.
	] ifFalse:[
		self initializeUpButton; 
			initializeDownButton; 
			initializePagingArea.
	].
	super initializeSlider.
	self roundedScrollbarLook ifTrue:[
		slider cornerStyle: #rounded.
		slider borderStyle: (BorderStyle complexRaised width: 3).
		sliderShadow cornerStyle: #rounded.
	].
	self sliderColor: self sliderColor.! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
scrollDelta: d1 pageDelta: d2
	"Supply optional increments for better scrolling of, eg, text"
	scrollDelta _ d1.
	pageDelta _ d2.! !

!OBScrollBar methodsFor: 'accessing' stamp: 'cwp 11/23/2003 18:06'!
adoptPaneColor: aColor
	"Adopt the given pane color"
	self alternativeScrollbarLook ifFalse:[^self].
	aColor ifNil:[^self].
	self sliderColor: aColor.! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollDown: count
	self setValue: (value + (scrollDelta * count) + 0.000001 min: 1.0)! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollBarAction: aSymbol
	self setProperty: #scrollBarAction toValue: aSymbol! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializeUpButton
	upButton := self roundedScrollbarLook 
				ifTrue:  
					[RectangleMorph 
						newBounds: (self innerBounds topLeft extent: self buttonExtent)]
				ifFalse: 
					[RectangleMorph 
						newBounds: ((self innerBounds topLeft) extent: self buttonExtent)].
	upButton color: self thumbColor.
	upButton 
		on: #mouseDown
		send: #scrollUpInit
		to: self.
	upButton 
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	upButton 
		addMorphCentered: (ImageMorph new image: (self 
						cachedImageAt: (bounds isWide ifTrue: ['left'] ifFalse: ['up'])
						ifAbsentPut: 
							[bounds isWide 
								ifTrue: [self upArrow8Bit rotateBy: #left centerAt: 0 @ 0]
								ifFalse: [self upArrow8Bit]])).
	self roundedScrollbarLook 
		ifTrue: 
			[upButton color: Color veryLightGray.
			upButton borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [upButton setBorderWidth: 1 borderColor: #raised].
	self addMorph: upButton! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:06'!
expandSlider
	"Compute the new size of the slider (use the old sliderThickness as a minimum)."
	| r |
	r _ self totalSliderArea.
	slider extent: (bounds isWide
		ifTrue: [((r width * interval) asInteger max: self sliderThickness) @ slider height]
		ifFalse: [slider width @ ((r height * interval) asInteger max: self sliderThickness)])! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
doScrollUp
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value - scrollDelta - 0.000001 max: 0.0)! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
thumbColor
	"Problem: Part of the ScrollBar/Slider code uses 'slider' to mean the entire scrollbar/slider widget, and part of it uses 'slider' to mean only the draggable 'thumb'.  This should be cleaned up so that 'thumb' is used instead of 'slider' where appropriate.  For now, the meaning of thumbColor is clear, at least."

	^ self alternativeScrollbarLook 
		ifTrue: [self sliderColor alphaMixed: 0.7 with: (Color gray: 0.95)]
		ifFalse: [Color veryLightGray]! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
pagingArea
	^pagingArea! !

!OBScrollBar methodsFor: 'stepping and presenter' stamp: 'cwp 11/23/2003 18:07'!
step
	| action |
	action _ self scrollBarAction.
	action ifNotNil:[self perform: action].! !

!OBScrollBar methodsFor: 'scroll timing' stamp: 'cwp 11/23/2003 18:07'!
waitForDelay1: delay1 delay2: delay2 
	"Return true if an appropriate delay has passed since the last scroll operation.
	The delay decreases exponentially from delay1 to delay2."

	| now scrollDelay |
	timeOfLastScroll isNil ifTrue: [self resetTimer].	"Only needed for old instances"
	now := Time millisecondClockValue.
	(scrollDelay := currentScrollDelay) isNil 
		ifTrue: [scrollDelay := delay1	"initial delay"].
	currentScrollDelay := scrollDelay * 9 // 10 max: delay2.	"decrease the delay"
	timeOfLastScroll := now.
	^true! !

!OBScrollBar methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2003 18:06'!
cachedImageAt: aKey ifAbsentPut: aBlock

	CachedImages ifNil: [CachedImages _ Dictionary new].
	^CachedImages at: aKey ifAbsentPut: aBlock! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
roundedScrollbarLook
	"Rounded look currently only shows up in flop-out mode"
	^Preferences alternativeScrollbarLook and: [Preferences inboardScrollbars not and: [self class alwaysShowFlatScrollbarForAlternativeLook not]]
! !

!OBScrollBar methodsFor: 'other events' stamp: 'cwp 11/23/2003 18:06'!
menuButtonMouseDown: event
	event hand showTemporaryCursor: nil.
	self use: menuSelector orMakeModelSelectorFor: 'MenuButtonPressed:'
		in: [:sel | menuSelector _ sel.  model perform: sel with: event]! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:06'!
buttonExtent
	^ bounds isWide
		ifTrue: [11 @ self innerBounds height]
		ifFalse: [self innerBounds width @ 11]! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
upArrow8Bit

	"convert to 8-bit and convert white to transparent to avoid gratuitous conversion every time we put one in an ImageMorph"

	^UpArrow8Bit ifNil: [
		UpArrow8Bit _ (ColorForm mappingWhiteToTransparentFrom: UpArrow) asFormOfDepth: 8
	]! !

!OBScrollBar class methodsFor: 'class initialization' stamp: 'cwp 11/23/2003 18:07'!
initialize "ScrollBar initialize"

	UpArrow _ Form
		extent: 6@3
		fromArray: #(2r11e28 2r1111e27 2r111111e26)
		offset: 0@0.! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
sliderColor: aColor
	"Change the color of the scrollbar to go with aColor."
	| buttonColor |
	super sliderColor: aColor.
	buttonColor _ self thumbColor.
	upButton color: buttonColor.
	downButton color: buttonColor.
	slider color: buttonColor.
	self alternativeScrollbarLook ifTrue:
		[self roundedScrollbarLook
			ifTrue:
				[self color: Color transparent.
				pagingArea color: aColor muchLighter.
				self borderStyle style == #simple 
					ifTrue:[self borderColor: aColor darker darker]
					ifFalse:[self borderStyle baseColor: aColor]]
			ifFalse:
				[pagingArea color: (aColor alphaMixed: 0.3 with: Color white).
				self borderWidth: 0]]
! !

!OBScrollBar methodsFor: 'model access' stamp: 'cwp 11/23/2003 18:06'!
setValue: newValue
	"Using roundTo: instead of truncateTo: ensures that scrollUp will scroll the same distance as scrollDown."
	^ super setValue: (newValue roundTo: scrollDelta)! !

Notification subclass: #OBTextRequest
	instanceVariableNames: 'prompt template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Notifications'!

!OBTextRequest methodsFor: 'accessing' stamp: 'cwp 2/2/2004 21:23'!
prompt: aString
	prompt _ aString! !

!OBTextRequest methodsFor: 'as yet unclassified' stamp: 'cwp 2/2/2004 21:27'!
requestText
	^ FillInTheBlankMorph 
		request: prompt
		initialAnswer: template
		centerAt: Sensor cursorPoint
		inWorld: World
		onCancelReturn: nil
		acceptOnCR: true! !

!OBTextRequest methodsFor: 'accessing' stamp: 'cwp 2/2/2004 20:59'!
template: aString
	template _ aString! !

!OBTextRequest methodsFor: 'accessing' stamp: 'cwp 2/2/2004 21:24'!
prompt
	^ prompt! !

!OBTextRequest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 20:31'!
prompt: promptString template: templateString
	^ (self new prompt: promptString; template: templateString) signal! !

!OBTextRequest methodsFor: 'as yet unclassified' stamp: 'cwp 2/2/2004 21:27'!
defaultAction
	self resume: self requestText! !

!OBTextRequest methodsFor: 'accessing' stamp: 'cwp 2/2/2004 21:00'!
template
	^ template! !

!OBTextRequest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/2/2004 21:30'!
prompt: aString
	^ self new prompt: aString; template: ''! !

Notification subclass: #OBNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Notifications'!

OBNotification subclass: #OBNodeDeleted
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Notifications'!

!OBNodeDeleted methodsFor: 'as yet unclassified' stamp: 'cwp 1/30/2004 00:33'!
notify: aMonitor
	aMonitor nodeDeleted! !

OBNotification subclass: #OBNodeSelected
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Notifications'!

!OBNodeSelected methodsFor: 'as yet unclassified' stamp: 'cwp 1/29/2004 23:37'!
node
	^ node! !

!OBNodeSelected methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 17:01'!
notify: aMonitor
	aMonitor nodeCreated: node! !

!OBNodeSelected methodsFor: 'as yet unclassified' stamp: 'cwp 1/29/2004 23:37'!
node: aNode
	node _ aNode! !

!OBNodeSelected class methodsFor: 'as yet unclassified' stamp: 'cwp 1/29/2004 23:37'!
for: aNode
	^ self new node: aNode! !

OBNotification subclass: #OBListChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Notifications'!

!OBListChanged methodsFor: 'as yet unclassified' stamp: 'cwp 1/30/2004 00:33'!
notify: aMonitor
	aMonitor listChanged! !

Notification subclass: #OBChoiceRequest
	instanceVariableNames: 'prompt options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Notifications'!

!OBChoiceRequest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 23:31'!
prompt: aString options: anArray
	^ (self new setPrompt: aString options: anArray) signal! !

!OBChoiceRequest methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 23:30'!
defaultAction
	^ options at: ((PopUpMenu labelArray: options) startUpWithCaption: prompt)
	! !

!OBChoiceRequest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 23:33'!
options: anArray
	^ (self new setOptions: anArray) signal! !

!OBChoiceRequest methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 23:25'!
setPrompt: aString options: anArray
	prompt _ aString.
	options _ anArray! !

!OBChoiceRequest methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 23:33'!
setOptions: anArray
	options _ anArray! !

!PluggableButtonMorph methodsFor: '*omnibrowser' stamp: 'cwp 2/24/2004 19:07'!
isOn
	^ self color = onColor! !

PackageInfo subclass: #OBFakePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFakePackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 23:31'!
systemCategoryPrefix
	^ 'OmniBrowser'! !

!OBFakePackage methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:42'!
systemCategories
	^ (SystemOrganization categories select: [:cat | cat includesSubString: 'OBContext']) 
		copyWith: #'OmniBrowser-Fakes'! !

!OBFakePackage methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2004 15:19'!
packageName
	^ 'OmniBrowserFakes'! !

OBFakePackage subclass: #OBFakeImageContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFakeImageContext methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2004 14:22'!
packages
	^ Array with: self! !

!OBFakePackage methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2004 13:56'!
classes
	^ (SystemOrganization listAtCategoryNamed: self systemCategoryPrefix, '-Fakes')
		collect: [:name | Smalltalk at: name].! !

!PackageInfo methodsFor: '*omnibrowser' stamp: 'cwp 12/14/2003 21:06'!
shortNameOf: aSystemCategoryName
	^ aSystemCategoryName allButFirst: self systemCategoryPrefix size + 1! !

!PackageInfo methodsFor: '*omnibrowser' stamp: 'cwp 1/29/2004 23:06'!
longNameOf: shortName
	^ self systemCategoryPrefix, '-', shortName
! !
OBBrowser initialize!
OBMetaGraphBuilder initialize!
OBScrollBar initialize!
